<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">

<html>
<head>
	<title>Character Generator</title>
	<link href="../Standard_Includes/Standard.css" type="text/css" rel="stylesheet" />
	<link href="Character_Generator.css" type="text/css" rel="stylesheet" />
	<script src="Array_Functions.js"></script>
	
	<script src="Lists.js"></script>
	<script src="Dice.js"></script>
	<script src="Requirements.js"></script>
	<script src="Choices.js"></script>
	<script src="Abilities.js"></script>
	<script src="Virtues_and_Vices.js"></script>
	<script src="Sizes.js"></script>
	<script src="Armor.js"></script>
	<script src="Weapons.js"></script>
	<script src="Skills.js"></script>
	<script src="Feats.js"></script>
	<script src="Powers.js"></script>
	<script src="Backgrounds.js"></script>
	<script src="Roles.js"></script>
	<script src="Characters.js"></script>
	<script src="Rules_Set.js"></script>
<script>
String.prototype.htmlEntities = function()
{
  var chars = new Array ('<','>');
  var entities = new Array ('lt','gt');
  newString = this;
  for (var i = 0; i < chars.length; i++)
  {
    myRegExp = new RegExp();
    myRegExp.compile(chars[i],'g')
    newString = newString.replace (myRegExp, '&' + entities[i] + ';');
  }
  return newString;
}
</script>
<script>
var ChoiceIndex = 0; // used to assign an index to each choice for background and level selection

function fShowImage( p_oElement )
{
	// do not show images if the skill row is empty
	var oObjL = p_oElement.previousSibling;
	if ( oObjL.tagName != "TD" ) // Firefox fix
		oObjL = oObjL.previousSibling;
	if ( oObjL.innerHTML == "&nbsp;" )
		return;
	
	p_oElement.childNodes[0].style.visibility = "visible";
}
function fHideImage( p_oElement )
{
	p_oElement.childNodes[0].style.visibility = "hidden";
}
function fShowImages( p_oElement )
{
	// do not show images if the skill row is empty
	if ( p_oElement.innerHTML == "&nbsp;" )
		return;
	
	var oObjL = p_oElement.previousSibling;
	var oObjR = p_oElement.nextSibling;
	
	if ( oObjL.tagName != "TD" ) // Firefox fix
	{
		oObjL = oObjL.previousSibling;
		oObjR = oObjR.nextSibling;
	}
	oObjL = oObjL.childNodes[0];
	oObjR = oObjR.childNodes[0];
	
	oObjL.style.visibility = "visible";
	oObjR.style.visibility = "visible";
}
function fHideImages( p_oElement )
{
	// do not hide images if the skill row is empty
	if ( p_oElement.innerHTML == "&nbsp;" )
		return;
	
	var oObjL = p_oElement.previousSibling;
	var oObjR = p_oElement.nextSibling;
	
	if ( oObjL.tagName != "TD" ) // Firefox
	{
		oObjL = oObjL.previousSibling;
		oObjR = oObjR.nextSibling;
	}
	oObjL = oObjL.childNodes[0];
	oObjR = oObjR.childNodes[0];
	
	oObjL.style.visibility = "hidden";
	oObjR.style.visibility = "hidden";
}

function fDisplayAbility( p_sAbility )
{
	document.getElementById( p_sAbility ).innerHTML = ( Char.abilities[ p_sAbility ] > 0 ? "+" : "" ) + Char.abilities[ p_sAbility ];
}
function fDisplayStat( p_sStat )
{
	var nValue = Char.getStat( p_sStat );
	
	switch ( p_sStat )
	{
		case "conviction":
			var oElement = document.getElementById( "convictionBoxes" );
			var oCheckbox = null;
			if ( nValue > 0 )
				oElement.innerHTML = "";
			else
				oElement.innerHTML = "&nbsp;";
			for ( var j = 0; j < nValue; j++ )
			{
				oCheckbox = document.createElement("input");
				oCheckbox.type = "checkbox";
				oElement.appendChild( oCheckbox );
			}
			break;
		case "reputation": // no plus sign is added
			break;
		default:
			nValue = ( nValue > 0 ? "+" : "" ) + nValue;
	}
	
	document.getElementById( p_sStat ).innerHTML = nValue;
}
function fDisplaySkillRank( p_sSkill )
{
	document.getElementById( p_sSkill ).cells[6].innerHTML = Char.skills[p_sSkill].ranks;
}
function fDisplaySkillTotal( p_sSkill )
{
	document.getElementById( p_sSkill ).cells[2].innerHTML = ( Char.skills[p_sSkill].total > 0 ? "+" : "" ) + Char.skills[p_sSkill].total;
}
function fInitializeArmorSelect()
{
	var oOption = null;
	var oArmor = document.getElementById("ArmorSelect");
	var cArmors = ArmorLists["no armor"].concat( ArmorLists["light"], ArmorLists["medium"], ArmorLists["heavy"] );
	
	for ( var i = 0; i < cArmors.length; i++ )
	{
		oOption = document.createElement("option");
		oArmor.appendChild( oOption );
		oOption.value = cArmors[i];
		oOption.innerHTML = Armors[ cArmors[i] ].name;
	}
}
function fDisplayArmor()
{
	var oArmor = document.getElementById("armor");
	oArmor.cells[1].innerHTML = ( Char.armor.bonus > 0 ? "+" : "" ) + Char.armor.bonus;
	oArmor.cells[2].innerHTML = Char.armor.penalty;
}
function fInitializeShieldSelect()
{
	var oOption = null;
	var oShield = document.getElementById("ShieldSelect");
	var cShields = ArmorLists["shields"];
	
	for ( var i = 0; i < cShields.length; i++ )
	{
		oOption = document.createElement("option");
		oShield.appendChild( oOption );
		oOption.value = cShields[i];
		oOption.innerHTML = Armors[ cShields[i] ].name;
	}
}
function fInitializeWeaponSelects()
{
	var oOption = null;
	var oMain = document.getElementById("mainWeapon");
	var oOff = document.getElementById("offWeapon");
	var oRanged = document.getElementById("rangedWeapon");
	
	for ( key in Weapons )
	{
		oOption = document.createElement("option");
		oOption.value = key;
		oOption.innerHTML = Weapons[ key ].name;
		
		if ( Weapons[key].mode == "melee" )
			oMain.appendChild( oOption.cloneNode(true) );
		if ( Weapons[key].mode == "melee" && Weapons[key].category != "two-handed" )
			oOff.appendChild( oOption.cloneNode(true) );
		if ( Weapons[key].mode == "ranged" )
			oRanged.appendChild( oOption.cloneNode(true) );
	}
}
function fDisplayWeapon( p_sLocation ) // main | off | ranged
{
	var oWeaponRow = document.getElementById( p_sLocation + "WeaponRow" );
	var oWeapon = null;
	var nAttack = "&nbsp;";
	var nDamage = "&nbsp;";
	var nRange = "&nbsp;";
	var sCrit = "&nbsp;";
	
	switch ( p_sLocation )
	{
		case "main":	oWeapon = Char.mainWeapon;		break;
		case "off":		oWeapon = Char.offWeapon;		break;
		case "ranged":	oWeapon = Char.rangedWeapon;	break;
	}
	
	if ( oWeapon )
	{
		nAttack = ( oWeapon.attack > 0 ? "+" : "" ) + oWeapon.attack;
		nDamage = ( oWeapon.damage > 0 ? "+" : "" ) + oWeapon.damage;
		nRange = oWeapon.range;
		sCrit = ( oWeapon.critRange > 1 ? (21 - oWeapon.critRange) + " - " + 20 : 20 ) + " / +" + oWeapon.critBonus;
	}
	
	oWeaponRow.cells[1].innerHTML = nAttack;
	oWeaponRow.cells[2].innerHTML = nDamage;
	oWeaponRow.cells[3].innerHTML = nRange;
	oWeaponRow.cells[4].innerHTML = sCrit;
}
function fDisplayShield()
{
	var oShield = document.getElementById("shield");
	oShield.cells[1].innerHTML = ( Char.shield.bonus > 0 ? "+" : "" ) + Char.shield.bonus;
	oShield.cells[2].innerHTML = Char.shield.penalty;
}
function fDisplaySize()
{
	document.getElementById( "size" ).innerHTML = Sizes[ Char.size ].name;
}
function fDisplayAbilityPointsSpent()
{
	document.getElementById( "AbilityPointsSpent" ).innerHTML = Char.abilityPointsSpent;
}
function fChangeBackground( p_sBackground )
{
	Char.setBackground( p_sBackground );
}
function fHideBackgroundChoices()
{
	document.getElementById( "BackgroundSelection" ).style.display = "none";
}
function fShowBackgroundChoices( p_sBackground )
{
	// reset choice index
	ChoiceIndex = 0;
	
	if ( p_sBackground == "" )
	{
		fCloseBackgroundSelection();
		return;
	}
	
	var oBG = Backgrounds[p_sBackground];
	
	// declaring UI element pointers
	var oBGName = document.getElementById( "BackgroundName" );
	var oBAM = document.getElementById( "BackgroundAbilityModifiers" );
	var oBS = document.getElementById( "BonusSkills" );
	var oBF = document.getElementById( "BonusFeats" );
	var oFF = document.getElementById( "FavoredFeats" );
	
	// removing old data
	oBGName.innerHTML = "";
	while ( oBAM.rows.length > 0 )
		oBAM.deleteRow(0);
	while ( oBS.rows.length > 0 )
		oBS.deleteRow(0);
	while ( oBF.rows.length > 0 )
		oBF.deleteRow(0);
	while ( oFF.rows.length > 0 )
		oFF.deleteRow(0);
	
	// showing the name
	oBGName.innerHTML = oBG.name;
	
	// declaring temp vars
	var oRow = null;
	var oCell = null;
	var oText = null;
	var oChoices = null;
	
	// showing the ability modifiers
	var oAM = oBG.abilityModifiers;
	for ( key in oAM )
	{
		oRow = document.createElement("tr");
		oBAM.appendChild( oRow );
		oCell = document.createElement("td");
		oRow.appendChild( oCell );
		oText = document.createTextNode( key );
		oCell.appendChild( oText );
		oCell = document.createElement("td");
		oCell.style.textAlign = "center";
		oRow.appendChild( oCell );
		oText = document.createTextNode( ( oAM[key] > 0 ? "+" : "" ) + oAM[key] );
		oCell.appendChild( oText );
	}
	
	// showing bonus skills
	var oBGBS =  document.getElementById( "BackgroundBonusSkills" );
	if ( oBG.bonusSkills )
	{
		oRow = document.createElement("tr");
		oCell = document.createElement("td");
		oCell.colSpan = 2;
		oCell.style.fontWeight = "bold";
		oText = document.createTextNode( "Bonus Skills" );
		oBS.appendChild( oRow );
		oRow.appendChild( oCell );
		oCell.appendChild( oText );
		
		oRow = document.createElement("tr");
		oBS.appendChild( oRow );
		oCell = document.createElement("td");
		oCell.colSpan = "2";
		oCell.style.paddingTop = "5px";
		oRow.appendChild( oCell );
		var oSelect = document.getElementById( "SkillSelectionSelect" ).cloneNode( false );
		oSelect.id = "";
		oSelect.choiceIndex = ChoiceIndex;
		ChoiceIndex++;
		oCell.appendChild( oSelect );
		var oOption = document.createElement("option");
		oSelect.appendChild( oOption );
		oOption.value = "";
		oText = document.createTextNode( "(select a skill)" );
		oOption.appendChild( oText );
		
		oSpecialty = document.createElement("select");
		oSpecialty.choiceIndex = ChoiceIndex;
		ChoiceIndex++;
		oSpecialty.style.width = "auto";
		oSpecialty.style.display = "none";
		oSpecialty.style.marginLeft = "5px";
		oCell.appendChild( oSpecialty );
		
		// adding the options
		for ( key in Skills )
		{
			oOption = document.createElement("option");
			oOption.value = key;
			oSelect.appendChild( oOption );
			oText = document.createTextNode( Skills[ key ].name );
			oOption.appendChild( oText );
		}
		
		// adding one extra choice for each option
		for ( var i = 1; i < oBG.bonusSkills; i++ )
			oBS.appendChild( oRow.cloneNode(true) );
		
		oBGBS.style.display = "block";
	}
	else
		oBGBS.style.display = "none";
	
	// adding in bonus feat and favored feat headers
	oRow = document.createElement("tr");
	oCell = document.createElement("td");
	oCell.colSpan = 2;
	oCell.style.fontWeight = "bold";
	oText = document.createTextNode( "Bonus Feats" );
	oBF.appendChild( oRow );
	oRow.appendChild( oCell );
	oCell.appendChild( oText );
	
	oRow = document.createElement("tr");
	oCell = document.createElement("td");
	oCell.colSpan = 2;
	oCell.style.fontWeight = "bold";
	oText = document.createTextNode( "Favored Feats" );
	oFF.appendChild( oRow );
	oRow.appendChild( oCell );
	oCell.appendChild( oText );
	
	// showing the bonus feats
	oChoices = oBG.bonusFeats;
	fCreateChoicesRows( oChoices, oBF );
	
	// showing the favored feats
	oChoices = oBG.favoredFeats;
	fCreateChoicesRows( oChoices, oFF );
	
	// displaying the background selection UI
	fDisableScreen();
	var oBGS = document.getElementById( "BackgroundSelection" );
	oBGS.style.display = "block";
	oBGS.style.top = ( document.body.clientHeight - oBGS.clientHeight ) / 2;
	oBGS.style.left = ( document.body.clientWidth - oBGS.clientWidth ) / 2;
}

function fDisableScreen()
{
	// lock resize or add onresize to ensure that it continues to stay covered
	var oBody = document.body;
	var oCover = document.getElementById( "ScreenCover" );
	
	oBody.style.overflow = "hidden";
	fResizeScreenCover();
	oCover.style.display = "block";
}
function fResizeScreenCover()
{
	var oBody = document.body;
	var oCover = document.getElementById( "ScreenCover" );
	
	oCover.style.height = oBody.clientHeight + oBody.scrollHeight;
	oCover.style.width = oBody.clientWidth + oBody.scrollWidth;
}
function fEnableScreen()
{
	// unlock if disable screen locks it resize
	var oBody = document.body;
	var oCover = document.getElementById( "ScreenCover" );
	oCover.style.display = "none";
	oBody.style.overflow = "auto";
}

function fCreateChoicesRows( p_oChoices, p_oTBody )
{
	// declaring temp vars
	var cChoices = new Array();
	var oChoice = null;
	var oObject = null;
	var oRow = null;
	var oCell = null;
	var oText = null;
	
	var nNumChoices = p_oChoices.numChoices;
	var nNumOptions = p_oChoices.getNumOptions();
	
	// if you have to choose X of Y options
	if ( nNumChoices != nNumOptions )
	{
		oRow = document.createElement("tr");
		p_oTBody.appendChild( oRow );
		
		oCell = document.createElement("td");
		oCell.style.paddingBottom = "5px";
		oCell.style.paddingTop = "5px";
		oCell.colSpan = 2;
		oCell.innerHTML = "<i>Select </i><b>" + nNumChoices + "</b><i> of the following </i><b>" + nNumOptions + "</b>";
		oRow.appendChild( oCell );
	}
	
	cChoices = p_oChoices.options;
	for ( var i = 0; i < cChoices.length; i++ )
	{
		oChoice = cChoices[i];
		oObject = oChoice.object;
		
		switch( oChoice.type )
		{
			case "SkillOption" :
				// TO DO: not supported yet
				break;
			case "FeatOption":
				sFeatID = oObject.id;
				oFeat = Feats[ sFeatID ];
				cSubtypes = oObject.subtypes;
				sRestriction = oObject.restriction;
				
				oRow = document.createElement("tr");
				p_oTBody.appendChild( oRow );
				
				oCell = document.createElement("td");
				oInput = document.getElementById("FeatSelectionCheckbox").cloneNode( false );
				oInput.choiceIndex = ChoiceIndex;
				ChoiceIndex++;
				oInput.disabled = false;
				oInput.value = sFeatID + "|" + String( cSubtypes ) + "|" + sRestriction;
				oRow.appendChild( oCell );
				oCell.appendChild( oInput );
				if ( nNumChoices == nNumOptions )
				{
					oInput.disabled = true;
					oInput.checked = true;
				}
				
				oCell = document.createElement("td");
				oText = document.createTextNode( oFeat.name + ( cSubtypes.length ? " (" + fsArrayToString( cSubtypes, "and" )  + ")" : "" ) );
				oRow.appendChild( oCell );
				if ( !sRestriction )
					oCell.appendChild( oText );
				else
				{
					oDIV = document.createElement("div");
					oCell.appendChild( oDIV );
					oDIV.appendChild( oText );
					
					oDIV = document.createElement("div");
					oDIV.style.fontStyle = "italic";
					oDIV.style.fontSize = "8pt";
					oText = document.createTextNode( sRestriction );
					oCell.appendChild( oDIV );
					oDIV.appendChild( oText );
				}
				break;
				
			case "ChoiceFeatList":
				var asFeats = new Array();
				var oFeatLists = oObject.featLists;
				for ( var i = 0; i < oFeatLists.length; i++ )
				{
					var oFeatList = FeatLists[ oFeatLists[i] ];
					for ( var j = 0; j < oFeatList.feats.length; j++ )
						asFeats.push( oFeatList.feats[j] );
				}
				
				// adding favored feats
				for ( var i = 0; i < Char.background.favoredFeats.length; i++ )
					asFeats.push( Char.background.favoredFeats[i].id );
				
				asFeats = asFeats.sort();
				if ( asFeats.length > 0 )
				{
					oRow = document.createElement("tr");
					p_oTBody.appendChild( oRow );
					oCell = document.createElement("td");
					oCell.colSpan = "2";
					oCell.style.paddingTop = "5px";
					oRow.appendChild( oCell );
					var oSelect = document.getElementById( "FeatSelectionSelect" ).cloneNode( false );
					oSelect.id = "";
					oSelect.choiceIndex = ChoiceIndex;
					ChoiceIndex++;
					oCell.appendChild( oSelect );
					var oOption = document.createElement("option");
					oSelect.appendChild( oOption );
					oOption.value = "";
					oText = document.createTextNode( "(select a feat)" );
					oOption.appendChild( oText );
					
					oSpecialty = document.getElementById( "FeatSelectionSelect" ).cloneNode( false );
					oSpecialty.id = "";
					oSpecialty.subtypeNum = 1;
					oSpecialty.choiceIndex = ChoiceIndex;
					ChoiceIndex++;
					oSpecialty.style.width = "auto";
					oSpecialty.style.display = "none";
					oSpecialty.style.marginLeft = "5px";
					oCell.appendChild( oSpecialty );
					
					oSpecialty = document.getElementById( "FeatSelectionSelect" ).cloneNode( false );
					oSpecialty.id = "";
					oSpecialty.subtypeNum = 2;
					oSpecialty.choiceIndex = ChoiceIndex;
					ChoiceIndex++;
					oSpecialty.style.width = "auto";
					oSpecialty.style.display = "none";
					oSpecialty.style.marginLeft = "5px";
					oCell.appendChild( oSpecialty );
					
					// adding the options
					for ( var i = 0; i < asFeats.length; i++ )
					{
						oOption = document.createElement("option");
						oOption.value = asFeats[i] + "||";
						oSelect.appendChild( oOption );
						oText = document.createTextNode( Feats[ asFeats[i] ].name );
						oOption.appendChild( oText );
					}
					
					// adding one extra choice for each option
					for ( var i = 1; i < oObject.numTimesToDisplay; i++ )
						p_oTBody.appendChild( oRow.cloneNode(true) );
				}
				break;
			case "Choices":
				fCreateChoicesRows( oObject, p_oTBody );
				break;
		}
	}
}
function fCheckboxChecked( p_oCheckbox )
{
	var sData = p_oCheckbox.value;
	var asData = sData.split("|");
	var asSubtypes = ( asData[1].length > 0 ? asData[1].split(",") : new Array() );
	
	if ( p_oCheckbox.checked )
		Char.addFeat({ "level" : "temp feat", "choice index" : p_oCheckbox.choiceIndex, "id" : asData[0], "subtypes" : asSubtypes, "restriction" : asData[2] });
	else
		Char.removeFeat({ "level" : "temp feat", "choice index" : p_oCheckbox.choiceIndex });
}
function fSelectSet( p_oSelect )
{
	if ( !p_oSelect.subtypeNum )
		fDisplaySubtype( p_oSelect );
	
	if ( p_oSelect.value == "" )
		return;
	
	// finding the true feat selector (and not just the subtype)
	var oFeatSelect = p_oSelect;
	while ( oFeatSelect.subtypeNum != null )
		oFeatSelect = oFeatSelect.previousSibling;
	
	// removing any temp feat associated with this selector
	Char.removeFeat({ "level" : "temp feat", "choice index" : oFeatSelect.choiceIndex });
	
	// verifying that all subtypes have been selected before submitting the data to the temp feats list
	var sFeatID = oFeatSelect.value.slice( 0, -2 );
	var oTempSelect = oFeatSelect;
	var asSubtypes = new Array();
	
	for ( var i = 0; i < Feats[ sFeatID ].numSubtypes + 1; i++ )
	{
		if ( oTempSelect.value == "" )
			return;
		if ( i > 0 ) // if this is a subtype and not the base select
			asSubtypes.push( oTempSelect.value );
		
		oTempSelect = oTempSelect.nextSibling;
	}
	
	Char.addFeat({ "level" : "temp feat", "choice index" : oFeatSelect.choiceIndex, "id" : sFeatID, "subtypes" : asSubtypes });
}

function fsArrayToString( p_aArray, p_sDivider )
{
	var sReturn = "";
	var nNumElements = p_aArray.length;
	
	for ( var i = 0; i < nNumElements; i++ )
		sReturn += p_aArray[i] + ( i != nNumElements - 1 ? " " + p_sDivider + " " : "" );
	
	return sReturn;
}
function fCloseBackgroundSelection()
{
	// removing temp feats
	for ( key in Char.tempFeats )
		Char.removeFeat({ "level" : "temp feat", "choice index" : key.slice(1) });
	
	fHideBackgroundChoices();
	fEnableScreen();
}
function fCloseSkillSelection()
{
	document.getElementById( "SkillSelection" ).style.display = "none";
	fEnableScreen();
}
function fHideRoleSelection()
{
	document.getElementById( "RoleSelection" ).style.display = "none";
}
function fShowRoleSelection()
{
	// displaying the background selection UI
	fDisableScreen();
	
	var oLevelRole = document.getElementById("LevelRole");
	if ( oLevelRole.value )
		fPopulateRoleData( oLevelRole.value );
	
	var oRS = document.getElementById( "RoleSelection" );
	oRS.style.display = "block";
	oRS.style.top = ( document.body.clientHeight - oRS.clientHeight ) / 2;
	oRS.style.left = ( document.body.clientWidth - oRS.clientWidth ) / 2;
}
function fCloseRoleSelection()
{
	// removing temp feats
	for ( key in Char.tempFeats )
		Char.removeFeat({ "level" : "temp feat", "choice index" : key.slice(1) });
	
	fHideRoleSelection();
	fEnableScreen();
}
function fSaveRoleSelection()
{
	var oLevelRole = document.getElementById("LevelRole");
	
	if ( oLevelRole.value == "" )
		return;
	
	var nLevel = Char.levels.length;
	var sSkillName = "";
	
	Char.addLevel( { "role" : oLevelRole.value } );
	
	// adding initial skills (only done at 1st level)
	if ( nLevel == 0 )
	{
		cElements = document.getElementById("LevelSkillsForm").elements;
		var nUnspentSkillPoints = 0;
		for ( var i = 0; i < cElements.length; i++ )
		{
			if ((( cElements[i].type == "checkbox" && cElements[i].checked ) || cElements[i].tagName == "SELECT" ))
			{
				if ( cElements[i].value )
				{
					if ( cElements[i].tagName == "SELECT" && cElements[i + 1].style.display == "inline" )
					{
						sSkillName = Skills[cElements[i].value].name + " (" + cElements[i + 1].value + ")";
						i++ // skips the specialty box
					}
					else
						sSkillName = Skills[cElements[i].value].name;
					Char.addInitialSkill( sSkillName );
				}
				else if ( cElements[i].style.display != "none" )
					nUnspentSkillPoints += 4;
			}
		}
		
		if ( nUnspentSkillPoints > 0 )
			Char.modifySkillPoints( nUnspentSkillPoints );
	}
	
	// adding feats
	cElements = document.getElementById("LevelFeatsForm").elements;
	for ( var i = 0; i < cElements.length; i++ )
	{
		if ( ( ( cElements[i].type == "checkbox" && cElements[i].checked ) || cElements[i].tagName == "SELECT" ) && cElements[i].value )
		{
			var sData = cElements[i].value;
			var asData = sData.split("|");
			var asSubtypes = ( asData[1].length > 0 ? asData[1].split(",") : new Array() );
			
			if ( cElements[i].tagName == "SELECT" )
			{
				if ( cElements[i + 2].style.display == "inline" )
					asSubtypes = new Array( cElements[i + 1].value, cElements[i + 2].value );
				else if ( cElements[i + 1].style.display == "inline" )
					asSubtypes = new Array( cElements[i + 1].value );
				
				// skipping the two subtype feat boxes
				i += 2;
			}
			Char.addFeat( { "level" : nLevel, "id" : asData[0], "subtypes" : asSubtypes, "restriction" : asData[2] } );
		}
	}
	
	fDisplayFeats();
	fDisplayRoles();
	
	fCloseRoleSelection();
}
function fDisplayRoles()
{
	var asRoleText = new Array();
	var asRoles = Char.roles;
	for ( key in asRoles )
		asRoleText.push( Roles[key].name + " " + asRoles[key] );
	document.getElementById( "RolesDisplay" ).innerHTML = String(asRoleText).replace(/,/g, " / ");
}
function fPopulateRoleData( p_sRole )
{
	var oLevelSkills = document.getElementById( "LevelSkillsForm" );
	var oLevelFeats = document.getElementById( "LevelFeatsForm" );
	var oRole = Roles[ p_sRole ];
	var oDIV = null;
	var oSelect = null;
	var oSpecialty = null;
	var oOption = null;
	var oText = null;
	
	// removing old data
	oLevelSkills.innerHTML = "";
	oLevelFeats.innerHTML = "";
	
	if ( !p_sRole )
		return;
	
	// determining skill point gain
	var nNumSkills = oRole.skillPoints + Char.abilities["INT"];
	if ( nNumSkills < 1 )
		nNumSkills = 1;
	
	// adding skills if this is first level
	if ( Char.levels.length == 0 )
	{
		oDIV = document.createElement("div");
		oDIV.style.marginTop = "10px";
		oDIV.style.fontWeight = "bold";
		oLevelSkills.appendChild( oDIV );
		oText = document.createTextNode( "Select your starting skills" );
		oDIV.appendChild( oText );
		
		oDIV = document.createElement("div");
		oDIV.style.marginTop = "5px";
		oLevelSkills.appendChild( oDIV );
		oSelect = document.getElementById( "SkillSelectionSelect" ).cloneNode( false );
		oSelect.id = "";
		oDIV.appendChild( oSelect );
		oOption = document.createElement("option");
		oSelect.appendChild( oOption );
		oText = document.createTextNode( "(select a skill)" );
		oOption.appendChild( oText );
		oOption.value = "";
		
		oSpecialty = document.createElement("select");
		oSpecialty.style.width = "auto";
		oSpecialty.style.display = "none";
		oSpecialty.style.marginLeft = "5px";
		oDIV.appendChild( oSpecialty );
		
		for ( key in Skills )
		{
			oOption = document.createElement("option");
			oSelect.appendChild( oOption );
			oOption.value = key;
			oText = document.createTextNode( Skills[key].name );
			oOption.appendChild( oText );
		}
		
		for ( var i = 1; i < nNumSkills; i++ )
			oLevelSkills.appendChild( oDIV.cloneNode(true) );
	}
	else // otherwise adding the number of skill points to be added
	{
		oDIV = document.createElement("div");
		oDIV.style.marginTop = "10px";
		oLevelSkills.appendChild( oDIV );
		oText = document.createTextNode( "You gain " + nNumSkills + " skill point" + ( nNumSkills > 1 ? "s" : "" ) + " this level" );
		oDIV.appendChild( oText );
	}
	
	oDIV = document.createElement("div");
	oDIV.style.marginTop = "10px";
	oDIV.style.fontWeight = "bold";
	oLevelFeats.appendChild( oDIV );
	oText = document.createTextNode( "Feats and Powers" );
	oDIV.appendChild( oText );
	
	// adding feats
	var oTable = document.createElement("table");
	oLevelFeats.appendChild( oTable );
	var oTBody = document.createElement("tbody");
	oTable.appendChild( oTBody );
	
	var oChoices = null;
	if ( Char.levels.length == 0 ) // this is the character's first level
		oChoices = oRole.initialLevel.options;
	else if ( Char.roles[p_sRole] ) // this is not the character's first level in this role
		oChoices = oRole.levels[ Char.roles[p_sRole] ].options;
	else // this is the first level in this role, but not the first level for the character
		oChoices = oRole.levels[0].options;
	
	fCreateChoicesRows( oChoices, oTBody );
}
function fSaveBackgroundOptions()
{
	var cElements = null;
	
	Char.setBackground( document.getElementById("Background").value );
	
	// adding bonus skills
	var nUnspentSkillPoints = 0;
	cElements = document.getElementById("BackgroundBonusSkills").elements;
	for ( var i = 0; i < cElements.length; i++ )
	{
		if ((( cElements[i].type == "checkbox" && cElements[i].checked ) || cElements[i].tagName == "SELECT" ))
		{
			if ( cElements[i].value )
			{
				if ( cElements[i].tagName == "SELECT" && cElements[i + 1].style.display == "inline" )
				{
					sSkillName = Skills[cElements[i].value].name + " (" + cElements[i + 1].value + ")";
					i++ // skips the specialty box
				}
				else
					sSkillName = Skills[cElements[i].value].name;
				Char.addBackgroundSkill( sSkillName );
			}
			else if ( cElements[i].style.display != "none" )
				nUnspentSkillPoints += 4;
		}
	}
	if ( nUnspentSkillPoints > 0 )
		Char.addBackgroundSkillPoints( nUnspentSkillPoints );
	
	// adding bonus feats
	cElements = document.getElementById("BackgroundBonusFeats").elements;
	for ( var i = 0; i < cElements.length; i++ )
	{
		if ( ( ( cElements[i].type == "checkbox" && cElements[i].checked ) || cElements[i].tagName == "SELECT" ) && cElements[i].value )
		{
			var sData = cElements[i].value;
			var asData = sData.split("|");
			var asSubtypes = ( asData[1].length > 0 ? asData[1].split(",") : new Array() );
			
			if ( cElements[i].tagName == "SELECT" )
			{
				if ( cElements[i + 2].style.display == "inline" )
					asSubtypes = new Array( cElements[i + 1].value, cElements[i + 2].value );
				else if ( cElements[i + 1].style.display == "inline" )
					asSubtypes = new Array( cElements[i + 1].value );
				
				// skipping the two subtype feat boxes
				i += 2;
			}
			Char.addFeat( { "level" : "background", "id" : asData[0], "subtypes" : asSubtypes, "restriction" : asData[2] } );
		}
	}
	
	// adding favored feats
	cElements = document.getElementById("BackgroundFavoredFeats").elements;
	for ( var i = 0; i < cElements.length; i++ )
	{
		if ( ( ( cElements[i].type == "checkbox" && cElements[i].checked ) || cElements[i].tagName == "SELECT" ) && cElements[i].value )
		{
			var sData = cElements[i].value;
			var asData = sData.split("|");
			var asSubtypes = ( asData[1].length > 0 ? asData[1].split(",") : new Array() );
			Char.addFeat( { "level" : "favored", "id" : asData[0], "subtypes" : asSubtypes } );
		}
	}
	
	fDisplayFeats();
	
	fCloseBackgroundSelection();
}
function fDisplayFeats()
{
	var sDisplay = "";
	var cRows = document.getElementById( "FeatsTable" ).rows;
	var cCells = null;
	var nCurrRow = 0;
	var nCurrCell = 0;
	var nTotalCells = cRows.length * 4;
	var sName = "";
	
	// displaying the core ability
	if ( Char.coreAbility )
	{
		cRows[nCurrRow].cells[nCurrCell].childNodes[0].innerHTML = "CA: " + Char.coreAbility; // the div in the cell
		cRows[nCurrRow].cells[nCurrCell].title = "Core Ability: " + Char.coreAbility;
		if ( nCurrCell == 3 )
			nCurrRow++;
		nCurrCell = ( nCurrCell + 1 ) % 4;
	}
	
	// displaying background feats
	cFeats = Char.background.feats;
	for ( var i = 0; i < cFeats.length; i++ )
	{
		sName = Feats[ cFeats[i].id ].name;
		sDisplay = sName;
		sDisplay += ( cFeats[i].subtypes.length > 0 ? " (" + String( cFeats[i].subtypes ).replace( /,/g, " and " ) + ") " : "" );
		sDisplay += ( cFeats[i].restriction ? cFeats[i].restriction : "" );
		
		cRows[nCurrRow].cells[nCurrCell].childNodes[0].innerHTML = "BG: " + sName; // the div in the cell
		cRows[nCurrRow].cells[nCurrCell].title = sDisplay;
		
		if ( nCurrCell == 3 )
			nCurrRow++;
		nCurrCell = ( nCurrCell + 1 ) % 4;
	}
	
	// displaying level feats
	var oFeat = null;
	for ( var i = 0; i < Char.levels.length; i++ )
	{
		cFeats = Char.levels[i].feats;
		for ( var j = 0; j < cFeats.length; j++ )
		{
			oFeat = cFeats[j];
			sName = Feats[ oFeat.id ].name;
			sDisplay = sName;
			sDisplay += ( oFeat.subtypes.length > 0 ? " (" + String( oFeat.subtypes ).replace( /,/g, " and " ) + ") " : "" );
			sDisplay += ( oFeat.restriction ? oFeat.restriction : "" );
			
			cRows[nCurrRow].cells[nCurrCell].childNodes[0].innerHTML = (i + 1) + ": " + sName; // the div in the cell
			cRows[nCurrRow].cells[nCurrCell].title = sDisplay;
			
			if ( nCurrCell == 3 )
				nCurrRow++;
			nCurrCell = ( nCurrCell + 1 ) % 4;
		}
	}
	
	// emptying out the rest of the fields
	for ( var i = ( nCurrRow * 4 ) + nCurrCell; i < nTotalCells; i++ )
	{
		cRows[nCurrRow].cells[nCurrCell].childNodes[0].innerHTML = "&nbsp;"; // the div in the cell
		cRows[nCurrRow].cells[nCurrCell].title = "";
		
		if ( nCurrCell == 3 )
			nCurrRow++;
		nCurrCell = ( nCurrCell + 1 ) % 4;
	}
}
function fDisplaySkills()
{
	var cRows = document.getElementById( "SkillsTable" ).rows;
	var cSkills = Char.skills;
	var nCurrRow = 0;
	var cCells = null;
	
	// sorting the skills
	var asSkills = new Array();
	for ( key in cSkills )
		asSkills.push( key );
	asSkills.sort();
	
	// adding skill rows
	var oSkill = null;
	for ( var i = 0; i < asSkills.length; i++ )
	{
		oSkill = cSkills[ asSkills[i] ];
		cRows[nCurrRow].id = asSkills[i];
		cCells = cRows[nCurrRow].cells;
		oDIV = cCells[0].childNodes[0];
		oDIV.style.paddingTop = "2px";
		oDIV.style.height = "16px";
		oDIV.innerHTML = oSkill.name; // on the div
		cCells[0].title = asSkills[i]; // on the td
		cCells[0].style.paddingTop = "1px";
		cCells[0].style.paddingLeft = "5px";
		cCells[2].innerHTML = ( oSkill.total > 0 ? "+" : "" ) + oSkill.total;
		cCells[4].innerHTML = oSkill.keyAbility;
		cCells[6].innerHTML = oSkill.ranks;
		nCurrRow++;
	}
	
	// add in a row for adding a rank to a new skill
	var oNewSkillButton = document.createElement("input");
	oNewSkillButton.type = "button";
	oNewSkillButton.value="Add Skill";
	oNewSkillButton.className = "Button";
	oNewSkillButton.onclick = fDisplayAddNewSkillSelection;
	cCells = cRows[nCurrRow].cells;
	cCells[0].title = ""; // on the td
	cCells[0].style.paddingTop = "0px"; // normally 1
	cCells[0].style.paddingLeft = "0px"; // normally 5
	cCells[2].innerHTML = "&nbsp;";
	cCells[4].innerHTML = "&nbsp;";
	cCells[6].innerHTML = "&nbsp;";
	oDIV = cCells[0].childNodes[0];
	oDIV.innerHTML = "";
	oDIV.style.paddingTop = "0px"; // normally 2
	oDIV.style.height = "19px"; // normally 16
	oDIV.appendChild( oNewSkillButton );
	nCurrRow++;
	
	// blanking out the remaining rows
	for ( var i = nCurrRow; i < cRows.length; i++ )
	{
		cRows[nCurrRow].removeAttribute( "id" );
		cCells = cRows[nCurrRow].cells;
		oDIV = cCells[0].childNodes[0];
		oDIV.innerHTML = ""; // on the div
		cCells[0].removeAttribute( "title" ); // on the td
		cCells[2].innerHTML = "&nbsp;";
		cCells[4].innerHTML = "&nbsp;";
		cCells[6].innerHTML = "&nbsp;";
	}
}
function fDisplayAddNewSkillSelection()
{
	fDisableScreen();
	
	// generating the skill list
	var oSelect = document.getElementById("SkillSelectionSelect");
	var oSpecialty = document.getElementById("SkillSpecialty");
	oSpecialty.style.display = "none";
	oSelect.innerHTML = "";
	var oOption = null;
	var oText = null;
	
	oOption = document.createElement("option");
	oSelect.appendChild( oOption );
	oOption.value = "";
	oText = document.createTextNode( "(select a skill)" );
	oOption.appendChild( oText );
	
	// TO DO: limit this to skills not known by the user
	for ( key in Skills )
	{
		if ( Skills[key].requiresTraining || Skills[key].specialties.length > 0 )
		{
			oOption = document.createElement("option");
			oSelect.appendChild( oOption );
			oOption.value = Skills[key].name;
			oText = document.createTextNode( Skills[key].name );
			oOption.appendChild( oText );
		}
	}
	
	var oANSS = document.getElementById( "SkillSelection" );
	oANSS.style.display = "block";
	oANSS.style.top = ( document.body.clientHeight - oANSS.clientHeight ) / 2;
	oANSS.style.left = ( document.body.clientWidth - oANSS.clientWidth ) / 2;
}
function fDisplaySubtype( p_oSelect )
{
	if ( p_oSelect.value == "" )
	{
		p_oSelect.nextSibling.style.display = "none";
		p_oSelect.nextSibling.nextSibling.style.display = "none";
		return;
	}
	
	var sFeatID = p_oSelect.value.split("|")[0];
	var nNumSubtypes = Feats[ sFeatID ].numSubtypes;
	var sSubtype = Feats[ sFeatID ].subtype;
	var oSubtype = p_oSelect; // actually just a placeholder which gets set to each subtype during the loop
	var oOption = null;
	var oText = null;
	
	// hiding all subtype selects
	for ( var i = 0; i < 2; i++ )
	{
		oSubtype = oSubtype.nextSibling;
		oSubtype.style.display = "none";
	}
	
	if ( nNumSubtypes == 0 )
		return;
	
	oSubtype = p_oSelect.nextSibling;
	oSubtype2 = oSubtype.nextSibling;
	oSubtype.innerHTML = "";
	oSubtype2.innerHTML = "";
	oOption = document.createElement("option");
	oSubtype.appendChild( oOption );
	oOption.value = "";
	oText = document.createTextNode( "(select a subtype)" );
	oOption.appendChild( oText );
	oSubtype2.appendChild( oOption.cloneNode(true) );
	
	switch ( sSubtype )
	{
		case "abilities":
			for ( var i = 0; i < Abilities.length; i++ )
			{
				oOption = document.createElement("option");
				oOption.value = Abilities[i];
				oText = document.createTextNode( Abilities[i] );
				oSubtype.appendChild( oOption );
				oOption.appendChild( oText );
				if ( nNumSubtypes == 2 )
					oSubtype2.appendChild( oOption.cloneNode(true) );
			}
			break;
		case "char weapons":
			var cProficiencies = Char.weaponProficiencies;
			for ( var i = 0; i < cProficiencies.length; i++ )
			{
				oOption = document.createElement("option");
				oOption.value = cProficiencies[i];
				oText = document.createTextNode( cProficiencies[i] );
				oSubtype.appendChild( oOption );
				oOption.appendChild( oText );
				if ( nNumSubtypes == 2 )
					oSubtype2.appendChild( oOption.cloneNode(true) );
			}
			break;
		case "true20 elements":
			for ( var i = 0; i < Lists["True20 Elements"].length; i++ )
			{
				oOption = document.createElement("option");
				oOption.value = Abilities[i];
				oText = document.createTextNode( Abilities[i] );
				oSubtype.appendChild( oOption );
				oOption.appendChild( oText );
				if ( nNumSubtypes == 2 )
					oSubtype2.appendChild( oOption.cloneNode(true) );
			}
			break;
		case "requirement":
			var cList = fasGetFeatSubtypes( Feats[ sFeatID ].requirements[0].id );
			for ( var i = 0; i < cList.length; i++ )
			{
				oOption = document.createElement("option");
				oOption.value = cList[i];
				oText = document.createTextNode( cList[i] );
				oSubtype.appendChild( oOption );
				oOption.appendChild( oText );
				if ( nNumSubtypes == 2 )
					oSubtype2.appendChild( oOption.cloneNode(true) );
			}
			break;
		case "char skills":
			for ( key in Char.skills )
			{
				oOption = document.createElement("option");
				oOption.value = key;
				oText = document.createTextNode( key );
				oSubtype.appendChild( oOption );
				oOption.appendChild( oText );
				if ( nNumSubtypes == 2 )
					oSubtype2.appendChild( oOption.cloneNode(true) );
			}
			break;
		default:
			// list object | list id
			var asData = sSubtype.split("|");
			var cList = eval( asData[0] + "[\"" + asData[1] + "\"]" );
			for ( var i = 0; i < cList.length; i++ )
			{
				oOption = document.createElement("option");
				oOption.value = cList[i];
				oText = document.createTextNode( cList[i] );
				oSubtype.appendChild( oOption );
				oOption.appendChild( oText );
				if ( nNumSubtypes == 2 )
					oSubtype2.appendChild( oOption.cloneNode(true) );
			}
	}
	
	oSubtype.style.display = "inline";
	if ( nNumSubtypes == 2 )
		oSubtype2.style.display = "inline";
}
function fasGetFeatSubtypes( p_sFeatID )
{
	var asSubtypes = new Array();
	var cFeats = Char.tempFeats;
	for ( key in cFeats )
	{
		if ( cFeats[ key ].id == p_sFeatID )
			asSubtypes = asSubtypes.concat( cFeats[ key ].subtypes );
	}
	cFeats = Char.background.feats;
	for ( var i = 0; i < cFeats.length; i++ )
	{
		if ( cFeats[i].id == p_sFeatID )
			asSubtypes = asSubtypes.concat( cFeats[i].subtypes );
	}
	for ( var i = 0; i < Char.levels.length; i++ )
	{
		cFeats = Char.levels[i].feats;
		for ( var j = 0; j < cFeats.length; j++ )
		{
			if ( cFeats[j].id == p_sFeatID )
				asSubtypes = asSubtypes.concat( cFeats[j].subtypes );
		}
	}
	
	return asSubtypes;
}
function fDisplaySpecialty( p_oSelect )
{
	var cSpecialties = Skills[ p_oSelect.value.toLowerCase() ].specialties;
	var oSpecialty = p_oSelect.nextSibling;
	
	if ( cSpecialties.length == 0 )
	{
		oSpecialty.style.display = "none";
		return;
	}
	
	oSpecialty.innerHTML = "";
	var oOption = null;
	var oText = null;
	
	oOption = document.createElement("option");
	oSpecialty.appendChild( oOption );
	oOption.value = "";
	oText = document.createTextNode( "(select a specialty)" );
	oOption.appendChild( oText );
	
	for ( var i = 0; i < cSpecialties.length; i++ )
	{
		oOption = document.createElement("option");
		oSpecialty.appendChild( oOption );
		oOption.value = cSpecialties[i];
		oText = document.createTextNode( cSpecialties[i] );
		oOption.appendChild( oText );
	}
	
	oSpecialty.style.display = "inline";
}
function fSaveSkillSelection()
{
	var sSpecialty = document.getElementById("SkillSpecialty");
	var sSkillID = document.getElementById("SkillSelectionSelect").value + ( sSpecialty.style.display != "inline" ? "" : " (" + sSpecialty.value + ")" );
	Char.modifySkillRanks( sSkillID, 1 );
	fCloseSkillSelection();
}
function fDisplaySkillPoints()
{
	document.getElementById( "SkillPoints" ).innerHTML = Char.skillPoints;
}
function fDisplaySkillPointsSpent()
{
	document.getElementById( "SkillPointsSpent" ).innerHTML = Char.skillPointsSpent;
}
function fGenerateRoleSelection()
{
	var cRoleOptions = document.getElementById("LevelRole");
	cRoleOptions = cRoleOptions.options;
	
	for ( key in Roles )
	{
		var oOption = document.createElement("option");
		cRoleOptions.add( oOption );
		oOption.value = key;
		oOption.innerHTML = Roles[key].name;
	}
}

function fValidateCharacter()
{
	var s = "";
	s += "Name: " + Char.name + "\n";
	for ( var i = 0; i < Char.background.favoredFeats.length; i++ )
		s += "FF: " + Char.background.favoredFeats[i].id + " " + Char.background.favoredFeats[i].subtypes + "\n";
	alert( s );
}
function fBodyOnLoad()
{
	// data initialization
	fInitializeArmor();
	fInitializeWeapons();
	fInitializeSkills();
	fInitializeSizes();
	fInitializeFeats();
	fInitializePowers();
	fInitializeBackgrounds();
	fInitializeRoles();
	
	// filling in equipment options
	fInitializeArmorSelect();
	fInitializeShieldSelect();
	fInitializeWeaponSelects();
	
	// filling in background options
	var oBackground = document.getElementById("Background");
	for ( key in Backgrounds )
	{
		var oOption = document.createElement("option");
		oBackground.options.add( oOption );
		oOption.value = key;
		oOption.innerHTML = Backgrounds[key].name;
	}
	
	// filling in virtues and vices
	var oVirtue = document.getElementById("Virtue");
	var oVice = document.getElementById("Vice");
	for ( var i = 0; i < Virtues.length; i++ )
	{
		var oOption = document.createElement("OPTION");
		oVirtue.options.add( oOption );
		oOption.value = Virtues[i];
		oOption.innerHTML = Virtues[i];
	}
	for ( var i = 0; i < Vices.length; i++ )
	{
		var oOption = document.createElement("OPTION");
		oVice.options.add( oOption );
		oOption.value = Vices[i];
		oOption.innerHTML = Vices[i];
	}
	
	// initializing character
	Char = new Character();
	
	// displaying specific character data
	fDisplaySkills();
	
	document.getElementById("CharacterName").select();
}
</script>
</head>

<body onload="fBodyOnLoad();" style="margin:0px;">
<form name="CharacterSheet">
<center>
<table id="CharTable" class="OuterTable" cellpadding="0" cellspacing="0" style="table-layout:fixed;">
<colgroup>
	<col style="width:100px;" />
	<col style="width:10px;" /><col style="width:30px;" /><col style="width:10px;" />
	<col style="width:50px;" /><col style="width:50px;" /><col style="width:50px;" />
	<col style="width:50px;" /><col style="width:50px;" /><col style="width:50px;" />
	<col style="width:100px;" /><col style="width:50px;" />
	<col style="width:260px;" />
</colgroup>
<tbody>

<tr>
	<td colspan="12" class="RightSection" style="height:24px;"><input type="text" name="CharacterName" id="CharacterName" maxlength="50" class="CharacterName" onchange="Char.setName(this.value);" value="(enter character name)" /></td>
	<td rowspan="31" style="vertical-align:top; padding:0px;">
		<table class="InnerTable" cellpadding="0" cellspacing="0">
			<colgroup>
				<col style="width:120px;" />
				<col style="width:10px;" /><col style="width:30px;" /><col style="width:10px;" />
				<col style="width:40px;" />
				<col style="width:10px;" /><col style="width:30px;" /><col style="width:10px;" />
			</colgroup>
			<thead>
				<tr>
					<td class="LeftSection" style="cursor:help; height:24px; text-align:left; padding-left:10px;" title="only skills that can be used are listed">Skill  (<span id="SkillPointsSpent">0</span> of <span id="SkillPoints">0</span>)</td>
					<td class="InnerSection" colspan="3" style="height:24px;">Total</td>
					<td class="InnerSection" style="cursor:help; height:24px;" title="key ability">Key</td>
					<td class="InnerSection" colspan="3" style="height:24px;">Rank</td>
				</tr>
			</thead>
			<tbody id="SkillsTable" style="height:600px; overflow:hidden;">
				<tr>
					<td class="SkillName"><div>&nbsp;<div></td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue" onmouseover="fShowImage(this);" onmouseout="fHideImage(this);" onclick="Char.modifySkillRanks(this.parentNode.cells[0].childNodes[0].innerHTML, -1);"><img src="decrease.gif" style="height:10px; width:10px;" /></td>
					<td class="SkillValue" onmouseover="fShowImages(this);" onmouseout="fHideImages(this);">&nbsp;</td>
					<td class="SkillValue" onmouseover="fShowImage(this);" onmouseout="fHideImage(this);" onclick="Char.modifySkillRanks(this.parentNode.cells[0].childNodes[0].innerHTML, 1);"><img src="increase.gif" style="height:10px; width:10px;" /></td>
				</tr>
				<tr>
					<td class="SkillName"><div>&nbsp;<div></td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue" onmouseover="fShowImage(this);" onmouseout="fHideImage(this);" onclick="Char.modifySkillRanks(this.parentNode.cells[0].childNodes[0].innerHTML, -1);"><img src="decrease.gif" style="height:10px; width:10px;" /></td>
					<td class="SkillValue" onmouseover="fShowImages(this);" onmouseout="fHideImages(this);">&nbsp;</td>
					<td class="SkillValue" onmouseover="fShowImage(this);" onmouseout="fHideImage(this);" onclick="Char.modifySkillRanks(this.parentNode.cells[0].childNodes[0].innerHTML, 1);"><img src="increase.gif" style="height:10px; width:10px;" /></td>
				</tr>
				<tr>
					<td class="SkillName"><div>&nbsp;<div></td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue" onmouseover="fShowImage(this);" onmouseout="fHideImage(this);" onclick="Char.modifySkillRanks(this.parentNode.cells[0].childNodes[0].innerHTML, -1);"><img src="decrease.gif" style="height:10px; width:10px;" /></td>
					<td class="SkillValue" onmouseover="fShowImages(this);" onmouseout="fHideImages(this);">&nbsp;</td>
					<td class="SkillValue" onmouseover="fShowImage(this);" onmouseout="fHideImage(this);" onclick="Char.modifySkillRanks(this.parentNode.cells[0].childNodes[0].innerHTML, 1);"><img src="increase.gif" style="height:10px; width:10px;" /></td>
				</tr>
				<tr>
					<td class="SkillName"><div>&nbsp;<div></td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue" onmouseover="fShowImage(this);" onmouseout="fHideImage(this);" onclick="Char.modifySkillRanks(this.parentNode.cells[0].childNodes[0].innerHTML, -1);"><img src="decrease.gif" style="height:10px; width:10px;" /></td>
					<td class="SkillValue" onmouseover="fShowImages(this);" onmouseout="fHideImages(this);">&nbsp;</td>
					<td class="SkillValue" onmouseover="fShowImage(this);" onmouseout="fHideImage(this);" onclick="Char.modifySkillRanks(this.parentNode.cells[0].childNodes[0].innerHTML, 1);"><img src="increase.gif" style="height:10px; width:10px;" /></td>
				</tr>
				<tr>
					<td class="SkillName"><div>&nbsp;<div></td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue" onmouseover="fShowImage(this);" onmouseout="fHideImage(this);" onclick="Char.modifySkillRanks(this.parentNode.cells[0].childNodes[0].innerHTML, -1);"><img src="decrease.gif" style="height:10px; width:10px;" /></td>
					<td class="SkillValue" onmouseover="fShowImages(this);" onmouseout="fHideImages(this);">&nbsp;</td>
					<td class="SkillValue" onmouseover="fShowImage(this);" onmouseout="fHideImage(this);" onclick="Char.modifySkillRanks(this.parentNode.cells[0].childNodes[0].innerHTML, 1);"><img src="increase.gif" style="height:10px; width:10px;" /></td>
				</tr>
				<tr>
					<td class="SkillName"><div>&nbsp;<div></td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue" onmouseover="fShowImage(this);" onmouseout="fHideImage(this);" onclick="Char.modifySkillRanks(this.parentNode.cells[0].childNodes[0].innerHTML, -1);"><img src="decrease.gif" style="height:10px; width:10px;" /></td>
					<td class="SkillValue" onmouseover="fShowImages(this);" onmouseout="fHideImages(this);">&nbsp;</td>
					<td class="SkillValue" onmouseover="fShowImage(this);" onmouseout="fHideImage(this);" onclick="Char.modifySkillRanks(this.parentNode.cells[0].childNodes[0].innerHTML, 1);"><img src="increase.gif" style="height:10px; width:10px;" /></td>
				</tr>
				<tr>
					<td class="SkillName"><div>&nbsp;<div></td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue" onmouseover="fShowImage(this);" onmouseout="fHideImage(this);" onclick="Char.modifySkillRanks(this.parentNode.cells[0].childNodes[0].innerHTML, -1);"><img src="decrease.gif" style="height:10px; width:10px;" /></td>
					<td class="SkillValue" onmouseover="fShowImages(this);" onmouseout="fHideImages(this);">&nbsp;</td>
					<td class="SkillValue" onmouseover="fShowImage(this);" onmouseout="fHideImage(this);" onclick="Char.modifySkillRanks(this.parentNode.cells[0].childNodes[0].innerHTML, 1);"><img src="increase.gif" style="height:10px; width:10px;" /></td>
				</tr>
				<tr>
					<td class="SkillName"><div>&nbsp;<div></td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue" onmouseover="fShowImage(this);" onmouseout="fHideImage(this);" onclick="Char.modifySkillRanks(this.parentNode.cells[0].childNodes[0].innerHTML, -1);"><img src="decrease.gif" style="height:10px; width:10px;" /></td>
					<td class="SkillValue" onmouseover="fShowImages(this);" onmouseout="fHideImages(this);">&nbsp;</td>
					<td class="SkillValue" onmouseover="fShowImage(this);" onmouseout="fHideImage(this);" onclick="Char.modifySkillRanks(this.parentNode.cells[0].childNodes[0].innerHTML, 1);"><img src="increase.gif" style="height:10px; width:10px;" /></td>
				</tr>
				<tr>
					<td class="SkillName"><div>&nbsp;<div></td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue" onmouseover="fShowImage(this);" onmouseout="fHideImage(this);" onclick="Char.modifySkillRanks(this.parentNode.cells[0].childNodes[0].innerHTML, -1);"><img src="decrease.gif" style="height:10px; width:10px;" /></td>
					<td class="SkillValue" onmouseover="fShowImages(this);" onmouseout="fHideImages(this);">&nbsp;</td>
					<td class="SkillValue" onmouseover="fShowImage(this);" onmouseout="fHideImage(this);" onclick="Char.modifySkillRanks(this.parentNode.cells[0].childNodes[0].innerHTML, 1);"><img src="increase.gif" style="height:10px; width:10px;" /></td>
				</tr>
				<tr>
					<td class="SkillName"><div>&nbsp;<div></td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue" onmouseover="fShowImage(this);" onmouseout="fHideImage(this);" onclick="Char.modifySkillRanks(this.parentNode.cells[0].childNodes[0].innerHTML, -1);"><img src="decrease.gif" style="height:10px; width:10px;" /></td>
					<td class="SkillValue" onmouseover="fShowImages(this);" onmouseout="fHideImages(this);">&nbsp;</td>
					<td class="SkillValue" onmouseover="fShowImage(this);" onmouseout="fHideImage(this);" onclick="Char.modifySkillRanks(this.parentNode.cells[0].childNodes[0].innerHTML, 1);"><img src="increase.gif" style="height:10px; width:10px;" /></td>
				</tr>
				<tr>
					<td class="SkillName"><div>&nbsp;<div></td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue" onmouseover="fShowImage(this);" onmouseout="fHideImage(this);" onclick="Char.modifySkillRanks(this.parentNode.cells[0].childNodes[0].innerHTML, -1);"><img src="decrease.gif" style="height:10px; width:10px;" /></td>
					<td class="SkillValue" onmouseover="fShowImages(this);" onmouseout="fHideImages(this);">&nbsp;</td>
					<td class="SkillValue" onmouseover="fShowImage(this);" onmouseout="fHideImage(this);" onclick="Char.modifySkillRanks(this.parentNode.cells[0].childNodes[0].innerHTML, 1);"><img src="increase.gif" style="height:10px; width:10px;" /></td>
				</tr>
				<tr>
					<td class="SkillName"><div>&nbsp;<div></td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue" onmouseover="fShowImage(this);" onmouseout="fHideImage(this);" onclick="Char.modifySkillRanks(this.parentNode.cells[0].childNodes[0].innerHTML, -1);"><img src="decrease.gif" style="height:10px; width:10px;" /></td>
					<td class="SkillValue" onmouseover="fShowImages(this);" onmouseout="fHideImages(this);">&nbsp;</td>
					<td class="SkillValue" onmouseover="fShowImage(this);" onmouseout="fHideImage(this);" onclick="Char.modifySkillRanks(this.parentNode.cells[0].childNodes[0].innerHTML, 1);"><img src="increase.gif" style="height:10px; width:10px;" /></td>
				</tr>
				<tr>
					<td class="SkillName"><div>&nbsp;<div></td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue" onmouseover="fShowImage(this);" onmouseout="fHideImage(this);" onclick="Char.modifySkillRanks(this.parentNode.cells[0].childNodes[0].innerHTML, -1);"><img src="decrease.gif" style="height:10px; width:10px;" /></td>
					<td class="SkillValue" onmouseover="fShowImages(this);" onmouseout="fHideImages(this);">&nbsp;</td>
					<td class="SkillValue" onmouseover="fShowImage(this);" onmouseout="fHideImage(this);" onclick="Char.modifySkillRanks(this.parentNode.cells[0].childNodes[0].innerHTML, 1);"><img src="increase.gif" style="height:10px; width:10px;" /></td>
				</tr>
				<tr>
					<td class="SkillName"><div>&nbsp;<div></td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue" onmouseover="fShowImage(this);" onmouseout="fHideImage(this);" onclick="Char.modifySkillRanks(this.parentNode.cells[0].childNodes[0].innerHTML, -1);"><img src="decrease.gif" style="height:10px; width:10px;" /></td>
					<td class="SkillValue" onmouseover="fShowImages(this);" onmouseout="fHideImages(this);">&nbsp;</td>
					<td class="SkillValue" onmouseover="fShowImage(this);" onmouseout="fHideImage(this);" onclick="Char.modifySkillRanks(this.parentNode.cells[0].childNodes[0].innerHTML, 1);"><img src="increase.gif" style="height:10px; width:10px;" /></td>
				</tr>
				<tr>
					<td class="SkillName"><div>&nbsp;<div></td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue" onmouseover="fShowImage(this);" onmouseout="fHideImage(this);" onclick="Char.modifySkillRanks(this.parentNode.cells[0].childNodes[0].innerHTML, -1);"><img src="decrease.gif" style="height:10px; width:10px;" /></td>
					<td class="SkillValue" onmouseover="fShowImages(this);" onmouseout="fHideImages(this);">&nbsp;</td>
					<td class="SkillValue" onmouseover="fShowImage(this);" onmouseout="fHideImage(this);" onclick="Char.modifySkillRanks(this.parentNode.cells[0].childNodes[0].innerHTML, 1);"><img src="increase.gif" style="height:10px; width:10px;" /></td>
				</tr>
				<tr>
					<td class="SkillName"><div>&nbsp;<div></td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue" onmouseover="fShowImage(this);" onmouseout="fHideImage(this);" onclick="Char.modifySkillRanks(this.parentNode.cells[0].childNodes[0].innerHTML, -1);"><img src="decrease.gif" style="height:10px; width:10px;" /></td>
					<td class="SkillValue" onmouseover="fShowImages(this);" onmouseout="fHideImages(this);">&nbsp;</td>
					<td class="SkillValue" onmouseover="fShowImage(this);" onmouseout="fHideImage(this);" onclick="Char.modifySkillRanks(this.parentNode.cells[0].childNodes[0].innerHTML, 1);"><img src="increase.gif" style="height:10px; width:10px;" /></td>
				</tr>
				<tr>
					<td class="SkillName"><div>&nbsp;<div></td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue" onmouseover="fShowImage(this);" onmouseout="fHideImage(this);" onclick="Char.modifySkillRanks(this.parentNode.cells[0].childNodes[0].innerHTML, -1);"><img src="decrease.gif" style="height:10px; width:10px;" /></td>
					<td class="SkillValue" onmouseover="fShowImages(this);" onmouseout="fHideImages(this);">&nbsp;</td>
					<td class="SkillValue" onmouseover="fShowImage(this);" onmouseout="fHideImage(this);" onclick="Char.modifySkillRanks(this.parentNode.cells[0].childNodes[0].innerHTML, 1);"><img src="increase.gif" style="height:10px; width:10px;" /></td>
				</tr>
				<tr>
					<td class="SkillName"><div>&nbsp;<div></td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue" onmouseover="fShowImage(this);" onmouseout="fHideImage(this);" onclick="Char.modifySkillRanks(this.parentNode.cells[0].childNodes[0].innerHTML, -1);"><img src="decrease.gif" style="height:10px; width:10px;" /></td>
					<td class="SkillValue" onmouseover="fShowImages(this);" onmouseout="fHideImages(this);">&nbsp;</td>
					<td class="SkillValue" onmouseover="fShowImage(this);" onmouseout="fHideImage(this);" onclick="Char.modifySkillRanks(this.parentNode.cells[0].childNodes[0].innerHTML, 1);"><img src="increase.gif" style="height:10px; width:10px;" /></td>
				</tr>
				<tr>
					<td class="SkillName"><div>&nbsp;<div></td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue" onmouseover="fShowImage(this);" onmouseout="fHideImage(this);" onclick="Char.modifySkillRanks(this.parentNode.cells[0].childNodes[0].innerHTML, -1);"><img src="decrease.gif" style="height:10px; width:10px;" /></td>
					<td class="SkillValue" onmouseover="fShowImages(this);" onmouseout="fHideImages(this);">&nbsp;</td>
					<td class="SkillValue" onmouseover="fShowImage(this);" onmouseout="fHideImage(this);" onclick="Char.modifySkillRanks(this.parentNode.cells[0].childNodes[0].innerHTML, 1);"><img src="increase.gif" style="height:10px; width:10px;" /></td>
				</tr>
				<tr>
					<td class="SkillName"><div>&nbsp;<div></td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue" onmouseover="fShowImage(this);" onmouseout="fHideImage(this);" onclick="Char.modifySkillRanks(this.parentNode.cells[0].childNodes[0].innerHTML, -1);"><img src="decrease.gif" style="height:10px; width:10px;" /></td>
					<td class="SkillValue" onmouseover="fShowImages(this);" onmouseout="fHideImages(this);">&nbsp;</td>
					<td class="SkillValue" onmouseover="fShowImage(this);" onmouseout="fHideImage(this);" onclick="Char.modifySkillRanks(this.parentNode.cells[0].childNodes[0].innerHTML, 1);"><img src="increase.gif" style="height:10px; width:10px;" /></td>
				</tr>
				<tr>
					<td class="SkillName"><div>&nbsp;<div></td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue" onmouseover="fShowImage(this);" onmouseout="fHideImage(this);" onclick="Char.modifySkillRanks(this.parentNode.cells[0].childNodes[0].innerHTML, -1);"><img src="decrease.gif" style="height:10px; width:10px;" /></td>
					<td class="SkillValue" onmouseover="fShowImages(this);" onmouseout="fHideImages(this);">&nbsp;</td>
					<td class="SkillValue" onmouseover="fShowImage(this);" onmouseout="fHideImage(this);" onclick="Char.modifySkillRanks(this.parentNode.cells[0].childNodes[0].innerHTML, 1);"><img src="increase.gif" style="height:10px; width:10px;" /></td>
				</tr>
				<tr>
					<td class="SkillName"><div>&nbsp;<div></td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue" onmouseover="fShowImage(this);" onmouseout="fHideImage(this);" onclick="Char.modifySkillRanks(this.parentNode.cells[0].childNodes[0].innerHTML, -1);"><img src="decrease.gif" style="height:10px; width:10px;" /></td>
					<td class="SkillValue" onmouseover="fShowImages(this);" onmouseout="fHideImages(this);">&nbsp;</td>
					<td class="SkillValue" onmouseover="fShowImage(this);" onmouseout="fHideImage(this);" onclick="Char.modifySkillRanks(this.parentNode.cells[0].childNodes[0].innerHTML, 1);"><img src="increase.gif" style="height:10px; width:10px;" /></td>
				</tr>
				<tr>
					<td class="SkillName"><div>&nbsp;<div></td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue" onmouseover="fShowImage(this);" onmouseout="fHideImage(this);" onclick="Char.modifySkillRanks(this.parentNode.cells[0].childNodes[0].innerHTML, -1);"><img src="decrease.gif" style="height:10px; width:10px;" /></td>
					<td class="SkillValue" onmouseover="fShowImages(this);" onmouseout="fHideImages(this);">&nbsp;</td>
					<td class="SkillValue" onmouseover="fShowImage(this);" onmouseout="fHideImage(this);" onclick="Char.modifySkillRanks(this.parentNode.cells[0].childNodes[0].innerHTML, 1);"><img src="increase.gif" style="height:10px; width:10px;" /></td>
				</tr>
				<tr>
					<td class="SkillName"><div>&nbsp;<div></td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue" onmouseover="fShowImage(this);" onmouseout="fHideImage(this);" onclick="Char.modifySkillRanks(this.parentNode.cells[0].childNodes[0].innerHTML, -1);"><img src="decrease.gif" style="height:10px; width:10px;" /></td>
					<td class="SkillValue" onmouseover="fShowImages(this);" onmouseout="fHideImages(this);">&nbsp;</td>
					<td class="SkillValue" onmouseover="fShowImage(this);" onmouseout="fHideImage(this);" onclick="Char.modifySkillRanks(this.parentNode.cells[0].childNodes[0].innerHTML, 1);"><img src="increase.gif" style="height:10px; width:10px;" /></td>
				</tr>
				<tr>
					<td class="SkillName"><div>&nbsp;<div></td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue" onmouseover="fShowImage(this);" onmouseout="fHideImage(this);" onclick="Char.modifySkillRanks(this.parentNode.cells[0].childNodes[0].innerHTML, -1);"><img src="decrease.gif" style="height:10px; width:10px;" /></td>
					<td class="SkillValue" onmouseover="fShowImages(this);" onmouseout="fHideImages(this);">&nbsp;</td>
					<td class="SkillValue" onmouseover="fShowImage(this);" onmouseout="fHideImage(this);" onclick="Char.modifySkillRanks(this.parentNode.cells[0].childNodes[0].innerHTML, 1);"><img src="increase.gif" style="height:10px; width:10px;" /></td>
				</tr>
				<tr>
					<td class="SkillName"><div>&nbsp;<div></td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue" onmouseover="fShowImage(this);" onmouseout="fHideImage(this);" onclick="Char.modifySkillRanks(this.parentNode.cells[0].childNodes[0].innerHTML, -1);"><img src="decrease.gif" style="height:10px; width:10px;" /></td>
					<td class="SkillValue" onmouseover="fShowImages(this);" onmouseout="fHideImages(this);">&nbsp;</td>
					<td class="SkillValue" onmouseover="fShowImage(this);" onmouseout="fHideImage(this);" onclick="Char.modifySkillRanks(this.parentNode.cells[0].childNodes[0].innerHTML, 1);"><img src="increase.gif" style="height:10px; width:10px;" /></td>
				</tr>
				<tr>
					<td class="SkillName"><div>&nbsp;<div></td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue" onmouseover="fShowImage(this);" onmouseout="fHideImage(this);" onclick="Char.modifySkillRanks(this.parentNode.cells[0].childNodes[0].innerHTML, -1);"><img src="decrease.gif" style="height:10px; width:10px;" /></td>
					<td class="SkillValue" onmouseover="fShowImages(this);" onmouseout="fHideImages(this);">&nbsp;</td>
					<td class="SkillValue" onmouseover="fShowImage(this);" onmouseout="fHideImage(this);" onclick="Char.modifySkillRanks(this.parentNode.cells[0].childNodes[0].innerHTML, 1);"><img src="increase.gif" style="height:10px; width:10px;" /></td>
				</tr>
				<tr>
					<td class="SkillName"><div>&nbsp;<div></td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue" onmouseover="fShowImage(this);" onmouseout="fHideImage(this);" onclick="Char.modifySkillRanks(this.parentNode.cells[0].childNodes[0].innerHTML, -1);"><img src="decrease.gif" style="height:10px; width:10px;" /></td>
					<td class="SkillValue" onmouseover="fShowImages(this);" onmouseout="fHideImages(this);">&nbsp;</td>
					<td class="SkillValue" onmouseover="fShowImage(this);" onmouseout="fHideImage(this);" onclick="Char.modifySkillRanks(this.parentNode.cells[0].childNodes[0].innerHTML, 1);"><img src="increase.gif" style="height:10px; width:10px;" /></td>
				</tr>
				<tr>
					<td class="SkillName"><div>&nbsp;<div></td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue">&nbsp;</td>
					<td class="SkillValue" onmouseover="fShowImage(this);" onmouseout="fHideImage(this);" onclick="Char.modifySkillRanks(this.parentNode.cells[0].childNodes[0].innerHTML, -1);"><img src="decrease.gif" style="height:10px; width:10px;" /></td>
					<td class="SkillValue" onmouseover="fShowImages(this);" onmouseout="fHideImages(this);">&nbsp;</td>
					<td class="SkillValue" onmouseover="fShowImage(this);" onmouseout="fHideImage(this);" onclick="Char.modifySkillRanks(this.parentNode.cells[0].childNodes[0].innerHTML, 1);"><img src="increase.gif" style="height:10px; width:10px;" /></td>
				</tr>
				<tr>
					<td class="SkillName" style="height:23px;"><div>&nbsp;<div></td>
					<td class="SkillValue" style="height:23px;">&nbsp;</td>
					<td class="SkillValue" style="height:23px;">&nbsp;</td>
					<td class="SkillValue" style="height:23px;">&nbsp;</td>
					<td class="SkillValue" style="height:23px;">&nbsp;</td>
					<td class="SkillValue" style="height:23px;" onmouseover="fShowImage(this);" onmouseout="fHideImage(this);" onclick="Char.modifySkillRanks(this.parentNode.cells[0].childNodes[0].innerHTML, -1);"><img src="decrease.gif" style="height:10px; width:10px;" /></td>
					<td class="SkillValue" style="height:23px;" onmouseover="fShowImages(this);" onmouseout="fHideImages(this);">&nbsp;</td>
					<td class="SkillValue" style="height:23px;" onmouseover="fShowImage(this);" onmouseout="fHideImage(this);" onclick="Char.modifySkillRanks(this.parentNode.cells[0].childNodes[0].innerHTML, 1);"><img src="increase.gif" style="height:10px; width:10px;" /></td>
				</tr>
			</tbody>
		</table>
	</td>
</tr>
<tr>
	<td class="Field">Roles</td>
	<td class="ValueRight" style="text-align:left;" colspan="11"><table class="LayoutTable" border="0" cellpadding="0" cellspacing="0"><tbody><tr><td><input type="button" name="AddRole" value="Add Level" onclick="fShowRoleSelection();" /></td><td id="RolesDisplay">&nbsp;</td></tr></tbody></table></td>
</tr>
<tr>
	<td class="Field">Background</td>
	<td class="Value" colspan="6">
		<select name="Background" id="Background" onchange="fShowBackgroundChoices(this.value);">
			<option value="">(select a background)</option>
		</select>
	</td>
	<td class="Field" colspan="2">Size</td>
	<td id="size" class="ValueRight" colspan="3">Medium</td>
</tr>
<tr>
	<td class="Field">Virtue</td>
	<td class="Value" colspan="6">
		<select name="Virtue" id="Virtue">
			<option value="">(select a virtue)</option>
		</select>
	</td>
	<td class="Field" colspan="2">Vice</td>
	<td class="ValueRight" colspan="3">
		<select name="Vice" id="Vice">
			<option value="">(select a vice)</option>
		</select>
	</td>
</tr>
<tr>
	<td class="InnerSection" colspan="4" style="text-align:left; padding-left:10px;">Abilities (<span id="AbilityPointsSpent">0</span> of <span id="AbilityPoints">6</span>)</td>
	<td class="RightSection" colspan="3">Saving Throws</td>
	<td class="DoubleSection" colspan="5">Combat</td>
</tr>
<tr>
	<td class="Field">Strength</td>
	<td class="ValueInner" onmouseover="fShowImage(this);" onmouseout="fHideImage(this);" onclick="Char.modifyBaseAbility('STR',-1);"><img src="decrease.gif" style="height:10px; width:10px;" /></td>
	<td id="STR" class="ValueInner" onmouseover="fShowImages(this);" onmouseout="fHideImages(this);">0</td>
	<td class="Value" onmouseover="fShowImage(this);" onmouseout="fHideImage(this);" onclick="Char.modifyBaseAbility('STR',1);"><img src="increase.gif" style="height:10px; width:10px;" /></td>
	<td class="Field" colspan="2">&nbsp;</td>
	<td class="ValueRight">&nbsp;</td>
	<td class="FieldLeft" colspan="2">Initiative</td>
	<td id="initiative" class="Value">0</td>
	<td class="Field">Speed</td>
	<td id="speed" class="ValueRight">30 ft</td>
</tr>
<tr>
	<td class="Field">Dexterity</td>
	<td class="ValueInner" onmouseover="fShowImage(this);" onmouseout="fHideImage(this);" onclick="Char.modifyBaseAbility('DEX',-1);"><img src="decrease.gif" style="height:10px; width:10px;" /></td>
	<td id="DEX" class="ValueInner" onmouseover="fShowImages(this);" onmouseout="fHideImages(this);">0</td>
	<td class="Value" onmouseover="fShowImage(this);" onmouseout="fHideImage(this);" onclick="Char.modifyBaseAbility('DEX',1);"><img src="increase.gif" style="height:10px; width:10px;" /></td>
	<td class="Field" colspan="2">Reflex</td>
	<td id="reflex" class="ValueRight">0</td>
	<td class="FieldLeft" colspan="2">Combat</td>
	<td id="combat" class="Value">0</td>
	<td class="Field">Defense</td>
	<td id="defense" class="ValueRight">0</td>
</tr>
<tr>
	<td class="Field">Constitution</td>
	<td class="ValueInner" onmouseover="fShowImage(this);" onmouseout="fHideImage(this);" onclick="Char.modifyBaseAbility('CON',-1);"><img src="decrease.gif" style="height:10px; width:10px;" /></td>
	<td id="CON" class="ValueInner" onmouseover="fShowImages(this);" onmouseout="fHideImages(this);">0</td>
	<td class="Value" onmouseover="fShowImage(this);" onmouseout="fHideImage(this);" onclick="Char.modifyBaseAbility('CON',1);"><img src="increase.gif" style="height:10px; width:10px;" /></td>
	<td class="Field" colspan="2">Fortitude</td>
	<td id="fortitude" class="ValueRight">0</td>
	<td class="FieldLeft" colspan="2">Melee</td>
	<td id="melee" class="Value">0</td>
	<td class="Field">Parry</td>
	<td id="parry" class="ValueRight">0</td>
</tr>
<tr>
	<td class="Field">Intelligence</td>
	<td class="ValueInner" onmouseover="fShowImage(this);" onmouseout="fHideImage(this);" onclick="Char.modifyBaseAbility('INT',-1);"><img src="decrease.gif" style="height:10px; width:10px;" /></td>
	<td id="INT" class="ValueInner" onmouseover="fShowImages(this);" onmouseout="fHideImages(this);">0</td>
	<td class="Value" onmouseover="fShowImage(this);" onmouseout="fHideImage(this);" onclick="Char.modifyBaseAbility('INT',1);"><img src="increase.gif" style="height:10px; width:10px;" /></td>
	<td class="Field" colspan="2">&nbsp;</td>
	<td class="ValueRight">&nbsp;</td>
	<td class="FieldLeft" colspan="2">Ranged</td>
	<td id="ranged" class="Value">0</td>
	<td class="Field">Dodge</td>
	<td id="dodge" class="ValueRight">0</td>
</tr>
<tr>
	<td class="Field">Wisdom</td>
	<td class="ValueInner" onmouseover="fShowImage(this);" onmouseout="fHideImage(this);" onclick="Char.modifyBaseAbility('WIS',-1);"><img src="decrease.gif" style="height:10px; width:10px;" /></td>
	<td id="WIS" class="ValueInner" onmouseover="fShowImages(this);" onmouseout="fHideImages(this);">0</td>
	<td class="Value" onmouseover="fShowImage(this);" onmouseout="fHideImage(this);" onclick="Char.modifyBaseAbility('WIS',1);"><img src="increase.gif" style="height:10px; width:10px;" /></td>
	<td class="Field" colspan="2">Will</td>
	<td id="will" class="ValueRight">0</td>
	<td class="FieldLeft" colspan="2">Grapple</td>
	<td id="grapple" class="Value">0</td>
	<td class="Field">Toughness</td>
	<td id="toughness" class="ValueRight">0</td>
</tr>
<tr>
	<td class="Field">Charisma</td>
	<td class="ValueInner" onmouseover="fShowImage(this);" onmouseout="fHideImage(this);" onclick="Char.modifyBaseAbility('CHA',-1);"><img src="decrease.gif" style="height:10px; width:10px;" /></td>
	<td id="CHA" class="ValueInner" onmouseover="fShowImages(this);" onmouseout="fHideImages(this);">0</td>
	<td class="Value" onmouseover="fShowImage(this);" onmouseout="fHideImage(this);" onclick="Char.modifyBaseAbility('CHA',1);"><img src="increase.gif" style="height:10px; width:10px;" /></td>
	<td class="Field" colspan="2">&nbsp;</td>
	<td class="ValueRight">&nbsp;</td>
	<td class="FieldLeft" colspan="2">Unarmed</td>
	<td id="unarmed" class="Value">0</td>
	<td class="Field" style="cursor:help;" title="unarmored toughness">Unarmored</td>
	<td id="unarmored toughness" class="ValueRight">0</td>
</tr>
<tr>
	<td class="InnerSection" colspan="5">Weapon</td>
	<td class="InnerSection" style="cursor:help;" title="includes the two weapon penalty if you are dual weilding">Attack</td>
	<td class="InnerSection" style="cursor:help;" title="damage">Dam</td>
	<td class="InnerSection">Range</td>
	<td class="Section" colspan="2">Crit</td>
	<td class="RightSection" colspan="2">&nbsp;</td>
</tr>
<tr id="mainWeaponRow">
	<td class="Value" colspan="5">
		<select id="mainWeapon" onchange="Char.equipWeapon('main', this.value);" style="width:200px;">
		</select>
	</td>
	<td class="Value">0</td>
	<td class="Value">0</td>
	<td class="Value">0</td>
	<td class="Value" colspan="2">20 / +3</td>
	<td class="ValueRight" colspan="2">&nbsp;</td>
</tr>
<tr id="offWeaponRow">
	<td class="Value" colspan="5">
		<select id="offWeapon" onchange="Char.equipWeapon('off', this.value);" style="width:200px;">
			<option value="">(empty off-hand)</option>
		</select>
	</td>
	<td class="Value">&nbsp;</td>
	<td class="Value">&nbsp;</td>
	<td class="Value">&nbsp;</td>
	<td class="Value" colspan="2">&nbsp;</td>
	<td class="ValueRight" colspan="2">&nbsp;</td>
</tr>
<tr id="rangedWeaponRow">
	<td class="Value" colspan="5">
		<select id="rangedWeapon" onchange="Char.equipWeapon('ranged', this.value);" style="width:200px;">
			<option value="">(no ranged weapon)</option>
		</select>
	</td>
	<td class="Value">&nbsp;</td>
	<td class="Value">&nbsp;</td>
	<td class="Value">&nbsp;</td>
	<td class="Value" colspan="2">&nbsp;</td>
	<td class="ValueRight" colspan="2">&nbsp;</td>
</tr>
<tr>
	<td class="InnerSection" colspan="5">Armor</td>
	<td class="InnerSection">Bonus</td>
	<td class="RightSection">Penalty</td>
	<td class="InnerSection" colspan="3">&nbsp;</td>
	<td class="RightSection" colspan="2">Value</td>
</tr>
<tr id="armor">
	<td class="Value" colspan="5">
		<select id="ArmorSelect" onchange="Char.equipArmor(this.value);" style="width:200px;">
		</select>
	</td>
	<td class="Value">0</td>
	<td class="Value">0</td>
	<td class="ValueRight" colspan="3">&nbsp;</td>
	<td class="Field">Wealth</td>
	<td class="ValueRight">0</td>
</tr>
<tr id="shield">
	<td class="Value" colspan="5">
		<select id="ShieldSelect" onchange="Char.equipShield(this.value);" style="width:200px;">
		</select>
	</td>
	<td class="Value">0</td>
	<td class="Value">0</td>
	<td class="ValueRight" colspan="3">&nbsp;</td>
	<td class="Field">Reputation</td>
	<td id="reputation" class="ValueRight">0</td>
</tr>
<tr>
	<td class="RightSection" colspan="12">Feats and Powers</td>
</tr>
<tr>
	<td class="Value" rowspan="7" colspan="12">
		<table class="InnerTable" cellpadding="0" cellspacing="0">
			<colgroup><col style="width:150px;" /><col style="width:150px;" /><col style="width:150px;" /><col style="width:150px;" /></colgroup>
			<tbody id="FeatsTable">
				<tr>
					<td class="TextValue"><div>&nbsp;</div></td>
					<td class="TextValueLeft"><div>&nbsp;</div></td>
					<td class="TextValue"><div>&nbsp;</div></td>
					<td class="TextValueLeft"><div>&nbsp;</div></td>
				</tr>
				<tr>
					<td class="TextValue"><div>&nbsp;</div></td>
					<td class="TextValueLeft"><div>&nbsp;</div></td>
					<td class="TextValue"><div>&nbsp;</div></td>
					<td class="TextValueLeft"><div>&nbsp;</div></td>
				</tr>
				<tr>
					<td class="TextValue"><div>&nbsp;</div></td>
					<td class="TextValueLeft"><div>&nbsp;</div></td>
					<td class="TextValue"><div>&nbsp;</div></td>
					<td class="TextValueLeft"><div>&nbsp;</div></td>
				</tr>
				<tr>
					<td class="TextValue"><div>&nbsp;</div></td>
					<td class="TextValueLeft"><div>&nbsp;</div></td>
					<td class="TextValue"><div>&nbsp;</div></td>
					<td class="TextValueLeft"><div>&nbsp;</div></td>
				</tr>
				<tr>
					<td class="TextValue"><div>&nbsp;</div></td>
					<td class="TextValueLeft"><div>&nbsp;</div></td>
					<td class="TextValue"><div>&nbsp;</div></td>
					<td class="TextValueLeft"><div>&nbsp;</div></td>
				</tr>
				<tr>
					<td class="TextValue"><div>&nbsp;</div></td>
					<td class="TextValueLeft"><div>&nbsp;</div></td>
					<td class="TextValue"><div>&nbsp;</div></td>
					<td class="TextValueLeft"><div>&nbsp;</div></td>
				</tr>
				<tr>
					<td class="TextValue" style="border-bottom:0px;"><div>&nbsp;</div></td>
					<td class="TextValueLeft" style="border-bottom:0px;"><div>&nbsp;</div></td>
					<td class="TextValue" style="border-bottom:0px;"><div>&nbsp;</div></td>
					<td class="TextValueLeft" style="border-bottom:0px;"><div>&nbsp;</div></td>
				</tr>
			</tbody>
		</table>
	</td>
</tr>
<tr></tr>
<tr></tr>
<tr></tr>
<tr></tr>
<tr></tr>
<tr></tr>
<tr>
	<td class="ValueRight" rowspan="5" colspan="12">
		<table cellpadding="0" cellspacing="0" style="border:0px; width:100%;">
			<tbody>
				<tr>
					<td class="TopDTValue">&gt;0</td></td>
					<td class="TopDTValue">5+</td>
					<td class="TopDTValue">10+</td>
					<td class="TopDTValue">15+</td>
					<td class="TopRightDTValue">20+</td>
					<td class="TopDTValue">&nbsp;</td>
					<td class="TopDTValue">&nbsp;</td>
					<td class="TopDTValue">&nbsp;</td>
				</tr>
				<tr>
					<td class="DTField">Bruised</td></td>
					<td class="DTField">Dazed</td>
					<td class="DTField">Staggered</td>
					<td class="DTField">Unconscious</td>
					<td class="RightDTField">&nbsp;</td>
					<td class="DTField">Winded</td>
					<td class="DTField">Fatigued</td>
					<td class="DTField">Exhausted</td>
				</tr>
				<tr>
					<td class="DTValue">&nbsp;</td></td>
					<td class="DTValue">&nbsp;</td>
					<td class="DTValue"><input type="checkbox"/></td>
					<td class="DTValue"><input type="checkbox"/></td>
					<td class="RightDTValue">&nbsp;</td>
					<td class="DTValue"><input type="checkbox"/></td>
					<td class="DTValue"><input type="checkbox"/></td>
					<td class="DTValue"><input type="checkbox"/></td>
				</tr>
				<tr>
					<td class="DTValue">&nbsp;</td></td>
					<td class="DTValue">&nbsp;</td>
					<td class="DTValue"><input type="checkbox"/></td>
					<td class="DTValue"><input type="checkbox"/></td>
					<td class="RightDTValue"><input type="checkbox"/></td>
					<td class="DTValue">&nbsp;</td>
					<td class="DTValue">&nbsp;</td>
					<td class="DTValue">&nbsp;</td>
				</tr>
				<tr>
					<td class="DTField">Hurt</td>
					<td class="DTField">Wounded</td>
					<td class="DTField">Disabled</td>
					<td class="DTField">Dying</td>
					<td class="RightDTField">Dead</td>
					<td class="DTField">&nbsp;</td>
					<td class="DTField">&nbsp;</td>
					<td class="DTField">&nbsp;</td>
				</tr>
			</tbody>
		</table>
	</td>
</tr>
<tr></tr>
<tr></tr>
<tr></tr>
<tr></tr>
<tr>
	<td class="Field" style="border:0px; border-top:1px solid black;">Conviction</td>
	<td id="conviction" class="Value" style="border:0px; border-top:1px solid black;" colspan="3">0</td>
	<td id="convictionBoxes" colspan="9" style="border:0px; border-top:1px solid black;">
		&nbsp;
		<!-- max of 29 checkboxes
		<input type="checkbox" />
		-->
	</td>
</tr>
<!--
NEXT TO EACH POWER
Power Rank

DAMAGE TRACKS
(include room for descriptions of conditions)
(possible better way to determine damage taken)

FEATS / POWERS
X: (X is a descriptor of how it's gained, most commonly background or level)
( && stacks on top of each other, || are side by side )

SPECIAL ABILITIES
(free form typing)

TO DO
attack focus not realizing you're also picking weapon training at the same time 
-->

</tbody>
</table>
</center>
<!--input type="button" class="Button" onclick="fValidateCharacter();" value="Validate" /-->
</form>

<div id="BackgroundSelection" class="Selection">
	<div style="height:360px; padding:10px; overflow:auto;">
		<div id="BackgroundName" style="font-size:10pt; font-weight:bold; margin-bottom:10px;"></div>
		<table cellpadding="0" cellspacing="0">
			<colgroup><col style="width:35px;" /><col /></colgroup>
			<tbody id="BackgroundAbilityModifiers">
			</tbody>
		</table>
		<form name="BackgroundBonusSkills" id="BackgroundBonusSkills" style="display:none; margin-top:10px;">
			<table cellpadding="0" cellspacing="0" style="width:100%;">
				<colgroup><col style="width:25px;" /><col /></colgroup>
				<tbody id="BonusSkills">
				</tbody>
			</table>
		</form>
		<form name="BackgroundBonusFeats" id="BackgroundBonusFeats">
			<table cellpadding="0" cellspacing="0" style="margin-top:10px; width:100%;">
				<colgroup><col style="width:25px;" /><col /></colgroup>
				<tbody id="BonusFeats">
				</tbody>
			</table>
		</form>
		<form name="BackgroundFavoredFeats" id="BackgroundFavoredFeats">
			<table cellpadding="0" cellspacing="0" style="margin-top:10px; width:100%;">
				<colgroup><col style="width:25px;" /><col /></colgroup>
				<tbody id="FavoredFeats">
				</tbody>
			</table>
		</form>
	</div>
	<form>
		<div style="height:20px; padding-bottom:5px; padding-top:5px; text-align:center;"><input type="button" class="Button" onclick="fSaveBackgroundOptions();" value="Save" /> <input type="button" class="Button" onclick="fCloseBackgroundSelection();" value="Cancel" /></div>
	</form>
</div>

<div id="RoleSelection" class="Selection">
<div style="height:360px; padding:10px; overflow:auto;">
<div>
	<div>
		<form name="RoleSelectionForm" id="RoleSelectionForm">
			<span style="font-weight:bold;">Select Role</span>
			<select name="LevelRole" id="LevelRole" style="margin-left:10px; width:auto;" onchange="fPopulateRoleData(this.value);">
				<option value="">(select a role)</option>
			</select>
		</form>
	</div>
	<table border="0" cellpadding="0" cellspacing="0" style="width:100%;">
		<colgroup><col style="width:60%;" /><col style="width:40%;" /></colgroup>
		<tbody>
			<tr>
				<td style="vertical-align:top;"><form name="LevelSkillsForm" id="LevelSkillsForm"></form></td>
			</tr>
			<tr>
				<td style="vertical-align:top;"><form name="LevelFeatsForm" id="LevelFeatsForm"></form></td>
			</tr>
		</tbody>
	</table>
</div>
</div>
<form>
	<div style="height:20px; padding-bottom:5px; padding-top:5px; text-align:center; background-color:#e0e0e0; border-top:2px outset #ffffff;"><input type="button" class="Button" onclick="fSaveRoleSelection();" value="Save" /> <input type="button" class="Button" onclick="fCloseRoleSelection();" value="Cancel" /></div>
</form>
</div>

<div id="SkillSelection" class="Selection">
<div style="height:100px; padding:10px; overflow:auto;">
	<form>
		<div style="padding-bottom:10px; text-align:center;"><span style="font-weight:bold;">Add a rank to </span><select id="SkillSelectionSelect" onchange="fDisplaySpecialty(this);" style="width:auto;"></select><select id="SkillSpecialty" style="margin-left:5px; width:auto; display:none;"></select></div>
		<div style="height:20px; padding-bottom:5px; padding-top:5px; text-align:center;"><input type="button" class="Button" onclick="fSaveSkillSelection();" value="Save" /> <input type="button" class="Button" onclick="fCloseSkillSelection();" value="Cancel" /></div>
	</form>
</div>
</div>

<div id="ScreenCover" style="background-color:#6699cc; position:absolute; top:0px; left:0px; z-index:100; opacity:.75;filter: alpha(opacity=75);"></div>

<!-- duplicated nodes to support events with parameters -->
<form style="display:none;">
<select id="FeatSelectionSelect" onchange="fSelectSet(this);" style="width:auto;"></select>
<input type="checkbox" id="FeatSelectionCheckbox" onclick="fCheckboxChecked(this);" />
</form>

<div id="Debugger" style="z-index:50000;">
</div>

</body>
</html>
