<?php
include("Standard_Includes/System_Globals.php");
include("Standard_Includes/Security.php");
include("Libraries/Select_Option_Generators.php");

$Options = array();
$Options["Abilities"] = fsGetOptions( array( "Table" => "True20_Abilities", "Value" => "Ability_ID", "Display" => "Name", "Order" => "Ability_ID" ) );
$Options["Stats"] = fsGetOptions( array( "Table" => "True20_Stats", "Value" => "Stat_ID", "Display" => "Name" ) );
$Options["Skills"] = fsGetOptions( array( "Table" => "True20_Skills", "Value" => "Skill_ID", "Display" => "Name" ) );
$Options["Feats"] = fsGetOptions( array( "Table" => "True20_Feats", "Value" => "Feat_ID", "Display" => "Name" ) );
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">

<html>
<head>
	<title>New Feat</title>
	<link href="Standard_Includes/Standard.css" rel="stylesheet" type="text/css" />
<script>
function fChangeRequirementCategory( p_oSelect )
{
	var oRow = p_oSelect.parentElement.parentElement;
	var nType = -1;
	
	switch ( p_oSelect.value )
	{
		case "ability":
			nType = 0;
			break;
		case "stat":
			nType = 1;
			break;
		case "skill":
			nType = 2;
			break;
		case "feat":
			nType = 3;
			break;
	}
	
	var nSelectNum = 0;
	var cNodes = oRow.cells[2].childNodes;
	var cNodes2 = oRow.cells[3].childNodes;
	for ( var i = 0; i < cNodes.length; i++ )
	{
		if ( cNodes[i].tagName != "SELECT" )
			continue;
		
		if ( nSelectNum != nType )
			cNodes[i].style.display = "none";
		else
			cNodes[i].style.display = "block";
		
		nSelectNum++;
	}
	
	nSelectNum = 0;
	cNodes = oRow.cells[3].childNodes;
	nType = ( nType != 3 ? 0 : 1 );
	for ( var i = 0; i < cNodes.length; i++ )
	{
		if ( cNodes[i].tagName != "SELECT" )
			continue;
		
		if ( nSelectNum != nType )
			cNodes[i].style.display = "none";
		else
			cNodes[i].style.display = "block";
		
		if ( cNodes[i].options.length == 0 )
			fFillNumericSelect( cNodes[i], -20, 20 );
		
		nSelectNum++;
	}
}
function fChangeModifierCategory( p_oSelect )
{
	var oRow = p_oSelect.parentElement.parentElement;
	var nType = -1;
	
	switch ( p_oSelect.value )
	{
		case "ability":
			nType = 0;
			break;
		case "stat":
			nType = 1;
			break;
		case "skill":
			nType = 2;
			break;
	}
	
	var nSelectNum = 0;
	var cNodes = oRow.cells[2].childNodes;
	for ( var i = 0; i < cNodes.length; i++ )
	{
		if ( cNodes[i].tagName != "SELECT" )
			continue;
		
		if ( nSelectNum != nType )
			cNodes[i].style.display = "none";
		else
			cNodes[i].style.display = "block";
		
		nSelectNum++;
	}
	oRow.cells[3].childNodes[0].style.display = "block";
	fChangeModifierType( oRow.cells[3].childNodes[0] );
}
function fChangeModifierType( p_oSelect )
{
	var oRow = p_oSelect.parentElement.parentElement;
	var cNodes = oRow.cells[4].childNodes;
	
	if ( cNodes[0].options.length == 0 )
		fFillNumericSelect( cNodes[0], -10, 10 );
	
	if ( p_oSelect.value == "numeric" )
	{
		cNodes[0].style.display = "block";
		cNodes[2].style.display = "none";
	}
	else // ability
	{
		cNodes[0].style.display = "none";
		cNodes[2].style.display = "block";
	}
}

function fRemoveRow( p_oRowMarker )
{
}

function fFillNumericSelect( p_oSelect, p_nMin, p_nMax )
{
	var oOption = null;
	var oText = null;
	
	for ( var i = p_nMax; i >= p_nMin; i-- )
	{
		oOption = document.createElement("option");
		oOption.value = i;
		p_oSelect.appendChild( oOption );
		oText = document.createTextNode( ( i > 0 ? "+" : "" ) + i );
		oOption.appendChild( oText );
		if ( i == 0 )
			oOption.selected = true;
	}
}

function fAddRequirement()
{
	var oTBody = document.getElementById("Requirements");
	oTBody.appendChild( oTBody.rows[0].cloneNode(true) );
}
function fAddModifier()
{
	var oTBody = document.getElementById("Modifiers");
	oTBody.appendChild( oTBody.rows[0].cloneNode(true) );
}
</script>
</head>

<body>

<form action="Save_Feat.php" method="post">
<table>
	<colgroup>
		<col />
		<col />
	</colgroup>
	<tbody>
		<tr>
			<td>Name</td>
			<td><input name="Name" id="Name" type="text" size="30" maxlength="50" value="<?php echo $Name; ?>" /></td>
		</tr>
		<tr>
			<td>Source</td>
			<td>
				<select name="Source_ID" id="Source_ID">
					<option value="">(select a source)</option>
<?php echo fsGetOptions( array( "Table" => "True20_Sources", "Value" => "Source_ID", "Display" => "Name", "Current Value" => $Source_ID ) ); ?>
				</select>
			</td>
		</tr>
		<tr>
			<td>Summary</td>
			<td><textarea name="Summary" id="Summary"><?php echo $Summary; ?></textarea></td>
		</tr>
		<tr>
			<td>Description</td>
			<td><textarea name="Description" id="Description"><?php echo $Description; ?></textarea></td>
		</tr>
		<tr>
			<td>Requirements</td>
			<td><input type="button" value="Add Requirement" onclick="fAddRequirement();" /></td>
		</tr>
		<tr>
			<td colspan="2">
				<table>
					<colgroup><col /><col /><col /></colgroup>
					<thead>
						<tr><td>&nbsp;</td><td>Category</td><td>Name</td><td>Requirement</td></tr>
					</thead>
					<tbody id="Requirements">
						<tr>
							<td onclick="fRemoveRow(this);">&nbsp;</td>
							<td>
								<select name="R_Category[]" onchange="fChangeRequirementCategory(this);">
									<option value="">(select a type)</option>
									<option value="ability">Ability</option>
									<option value="stat">Stat</option>
									<option value="skill">Skill</option>
									<option value="feat">Feat</option>
								</select>
							</td>
							<td>
								<select name="R_ID_ability[]" style="display:none;">
									<option value="">(select an ability)</option>
<?php echo $Options["Abilities"] ?>
								</select><select name="R_ID_stat[]" style="display:none;">
									<option value="">(select a stat)</option>
<?php echo $Options["Stats"] ?>
								</select>
								<select name="R_ID_skill[]" style="display:none;">
									<option value="">(select a skill)</option>
<?php echo $Options["Skills"] ?>
								</select>
								<select name="R_ID_feat[]" style="display:none;">
									<option value="">(select a feat)</option>
<?php echo $Options["Feats"] ?>
								</select>
							</td>
							<td>
								<select name="R_Requirement_numeric[]" style="display:none;">
								</select>
								<select name="R_Requirement_feat[]" style="display:none;">
									<option value="1">possesses</option>
								</select>
							</td>
						</tr>
					</tbody>
				</table>
			</td>
		</tr>
		<tr>
			<td>Modifiers</td>
			<td><input type="button" value="Add Modifier" onclick="fAddModifier();" /></td>
		</tr>
		<tr>
			<td colspan="2">
				<table>
					<colgroup><col /><col /><col /><col /></colgroup>
					<thead>
						<tr><td>&nbsp;</td><td>Category</td><td>Name</td><td>Type</td><td>Modifier</td></tr>
					</thead>
					<tbody id="Modifiers">
						<tr>
							<td onclick="fRemoveRow(this);">&nbsp;</td>
							<td>
								<select name="M_Category[]" onchange="fChangeModifierCategory(this);">
									<option value="">(select a type)</option>
									<option value="ability">Ability</option>
									<option value="stat">Stat</option>
									<option value="skill">Skill</option>
								</select>
							</td>
							<td>
								<select name="M_ID_ability[]" style="display:none;">
									<option value="">(select an ability)</option>
<?php echo $Options["Abilities"] ?>
								</select><select name="M_ID_stat[]" style="display:none;">
									<option value="">(select a stat)</option>
<?php echo $Options["Stats"] ?>
								</select>
								<select name="M_ID_skill[]" style="display:none;">
									<option value="">(select a skill)</option>
<?php echo $Options["Skills"] ?>
								</select>
							</td>
							<td>
								<select name="M_Type[]" style="display:none;" onchange="fChangeModifierType(this);">
									<option value="numeric" selected>Numeric</option>
									<option value="ability">Ability</option>
								</select>
							</td>
							<td>
								<select name="M_Modifier_numeric[]" style="display:none;">
								</select>
								<select name="M_Modifier_ability[]" style="display:none;">
<?php echo $Options["Abilities"] ?>
								</select>
							</td>
						</tr>
					</tbody>
				</table>
			</td>
		</tr>
		<tr><td>&nbsp;</td><td><input type="submit" value="Save" /></td></tr>
	</tbody>
</table>
<input type="hidden" name="User_ID" value="<?php echo $User_ID; ?>" />
<input type="hidden" name="Password" value="<?php echo $Password; ?>" />
</form>

</body>
</html>
