function Skill( p_aParams )
{
	this.name = p_aParams["name"];
	this.source = p_aParams["source"];
	this.keyAbility = p_aParams["key ability"];
	this.description = ( p_aParams["description"] ? p_aParams["description"] : "" );
	this.specialties = ( p_aParams["specialties"] ? p_aParams["specialties"] : new Array() );
	this.requiresTraining = ( p_aParams["requires training"] ? p_aParams["requires training"] : false );
	this.armorPenalty = ( p_aParams["armor penalty"] ? p_aParams["armor penalty"] : 0 );
}

function fInitializeSkills()
{
	Skills = new Array();
	
	Skills["acrobatics"] = new Skill( {
		"name" : "Acrobatics",
		"source" : "True20 Adventure Roleplaying",
		"key ability" : "DEX",
		"requires training" : true,
		"armor penalty" : 1
	} );
	Skills["bluff"] = new Skill( {
		"name" : "Bluff",
		"source" : "True20 Adventure Roleplaying",
		"key ability" : "CHA",
		"requires training" : false
	} );
	Skills["climb"] = new Skill( {
		"name" : "Climb",
		"source" : "True20 Adventure Roleplaying",
		"key ability" : "STR",
		"requires training" : false,
		"armor penalty" : 1
	} );
	Skills["computers"] = new Skill( {
		"name" : "Computers",
		"source" : "True20 Adventure Roleplaying",
		"key ability" : "INT",
		"requires training" : true
	} );
	Skills["concentration"] = new Skill( {
		"name" : "Concentration",
		"source" : "True20 Adventure Roleplaying",
		"key ability" : "WIS",
		"requires training" : false
	} );
	Skills["craft"] = new Skill
	( {
		"name" : "Craft",
		"source" : "True20 Adventure Roleplaying",
		"key ability" : "INT",
		"requires training" : true,
		"specialties" : new Array(
			"blacksmith",
			"brewing",
			"leatherworking",
			"mechanics",
			"weaving"
		)
	} );
	Skills["diplomacy"] = new Skill
	( {
		"name" : "Diplomacy",
		"source" : "True20 Adventure Roleplaying",
		"key ability" : "CHA",
		"requires training" : false
	} );
	Skills["disable device"] = new Skill
	( {
		"name" : "Disable Device",
		"source" : "True20 Adventure Roleplaying",
		"key ability" : "INT",
		"requires training" : true
	} );
	Skills["disguise"] = new Skill
	( {
		"name" : "Disguise",
		"source" : "True20 Adventure Roleplaying",
		"key ability" : "CHA",
		"requires training" : false
	} );
	Skills["drive"] = new Skill
	( {
		"name" : "Drive",
		"source" : "True20 Adventure Roleplaying",
		"key ability" : "DEX",
		"requires training" : true
	} );
	Skills["escape artist"] = new Skill
	( {
		"name" : "Escape Artist",
		"source" : "True20 Adventure Roleplaying",
		"key ability" : "DEX",
		"requires training" : false,
		"armor penalty" : 1
	} );
	Skills["gather information"] = new Skill
	( {
		"name" : "Gather Information",
		"source" : "True20 Adventure Roleplaying",
		"key ability" : "CHA",
		"requires training" : false
	} );
	Skills["handle animal"] = new Skill
	( {
		"name" : "Handle Animal",
		"source" : "True20 Adventure Roleplaying",
		"key ability" : "CHA",
		"requires training" : false
	} );
	Skills["intimidate"] = new Skill
	( {
		"name" : "Intimidate",
		"source" : "True20 Adventure Roleplaying",
		"key ability" : "CHA",
		"requires training" : false
	} );
	Skills["jump"] = new Skill
	( {
		"name" : "Jump",
		"source" : "True20 Adventure Roleplaying",
		"key ability" : "STR",
		"requires training" : false,
		"armor penalty" : 1
	} );
	Skills["knowledge"] = new Skill
	( {
		"name" : "Knowledge",
		"source" : "True20 Adventure Roleplaying",
		"key ability" : "INT",
		"requires training" : true,
		"specialties" : new Array(
			"art",
			"behavior sciences",
			"business",
			"civics",
			"current events",
			"earth sciences",
			"history",
			"life sciences",
			"physical sciences",
			"popular culture",
			"streetwise",
			"supernatural",
			"tactics",
			"technology",
			"theology and philosophy"
		)
	} );
	Skills["medicine"] = new Skill
	( {
		"name" : "Medicine",
		"source" : "True20 Adventure Roleplaying",
		"key ability" : "WIS",
		"requires training" : true
	} );
	Skills["notice"] = new Skill
	( {
		"name" : "Notice",
		"source" : "True20 Adventure Roleplaying",
		"key ability" : "WIS",
		"requires training" : false
	} );
	Skills["perform"] = new Skill
	( {
		"name" : "Perform",
		"source" : "True20 Adventure Roleplaying",
		"key ability" : "CHA",
		"requires training" : false,
		"specialties" : new Array(
			"acting",
			"comedy",
			"dance",
			"oratory",
			"percussion instruments",
			"singing",
			"stringed instruments",
			"woodwind instruments"
		)
	} );
	Skills["pilot"] = new Skill
	( {
		"name" : "Pilot",
		"source" : "True20 Adventure Roleplaying",
		"key ability" : "DEX",
		"requires training" : true
	} );
	Skills["ride"] = new Skill
	( {
		"name" : "Ride",
		"source" : "True20 Adventure Roleplaying",
		"key ability" : "CHA",
		"requires training" : true
	} );
	Skills["search"] = new Skill
	( {
		"name" : "Search",
		"source" : "True20 Adventure Roleplaying",
		"key ability" : "CHA",
		"requires training" : false
	} );
	Skills["sense motive"] = new Skill
	( {
		"name" : "Sense Motive",
		"source" : "True20 Adventure Roleplaying",
		"key ability" : "WIS",
		"requires training" : false
	} );
	Skills["sleight of hand"] = new Skill
	( {
		"name" : "Sleight of Hand",
		"source" : "True20 Adventure Roleplaying",
		"key ability" : "DEX",
		"requires training" : true,
		"armor penalty" : 1
	} );
	Skills["stealth"] = new Skill
	( {
		"name" : "Stealth",
		"source" : "True20 Adventure Roleplaying",
		"key ability" : "DEX",
		"requires training" : false,
		"armor penalty" : 1
	} );
	Skills["survival"] = new Skill
	( {
		"name" : "Survival",
		"source" : "True20 Adventure Roleplaying",
		"key ability" : "WIS",
		"requires training" : false
	} );
	Skills["swim"] = new Skill
	( {
		"name" : "Swim",
		"source" : "True20 Adventure Roleplaying",
		"key ability" : "STR",
		"requires training" : false,
		"armor penalty" : 2
	} );
}